function getIndexer(%testVar, %indexer, %raw)
{
	if (%raw)
	{
		%dotPos = strPos(%indexer, "..");
		if (%dotPos != -1)
		{
			%val0 = getSubStr(%indexer, 0, %dotPos);
			%val1 = getSubStr(%indexer, %dotPos + 2, strLen(%indexer) - (%dotPos + 2));
			if (%val0 > %val1)
			{
				%temp = %val1;
				%val1 = %val0;
				%val0 = %temp;
				%reverse = 1;
			}
			%start = getMax(%val0, 0);
			%end = getMin(%val1, strLen(%testVar) - 1);
			%substr = getSubStr(%testVar, %start, (%end + 1) - %start);
			if (%reverse)
			{
				%len = strLen(%substr);
				for (%i = 0; %i < %len; %i++)
					%newSubstr = getSubStr(%substr, %i, 1) @ %newSubstr;
				%substr = %newSubstr;
			}
			return %substr;
		}
		else if (strStartsWith(%indexer, "="))
		{
			if (!isObject(%testVar))
				return "";
			%indexer = collapseEscape(getSubStr(%indexer, 1, strLen(%indexer) - 1));
			%set = new ScriptObject() { class = "SimList"; };
			%set.transient = %set.schedule(0, "delete");
			if (%testVar.getID() == ClientGroup.getID())
			{
				%group = ClientGroup;
				%count = %group.getCount();
				for (%i = 0; %i < %count; %i++)
				{
					%client = %group.getObject(%i);
					%namePos = striPos(%client.name, %indexer);
					if (%namePos != -1)
						%set.add(%client);
					else if (%client.bl_id == %indexer)
						%set.add(%client);
					else if (%indexer == %i)
						%set.add(%client);
				}
			}
			return %set;
		}
	}
	else
	{
		if (isObject(%testVar))
		{
			if (%testVar.getID() == ClientGroup.getID())
			{
				%group = ClientGroup;
				%count = %group.getCount();
				if (%indexer !$= "" && strPos("0123456789", getSubStr(%indexer, 0, 1)) == -1)
					%nonnumeric = 1;
				for (%i = 0; %i < %count; %i++)
				{
					%client = %group.getObject(%i);
					%nameIPos = striPos(%client.name, %indexer);
					%namePos = strPos(%client.name, %indexer);
					if (%namePos != -1)
					{
						if (%namePos < %nameWinPos || %nameWinPos $= "")
						{
							%nameWinPos = %namePos;
							%nameWinner = %client;
						}
					}
					else if (%nameIPos != -1)
					{
						if (%nameIPos < %nameIWinPos || %nameIWinPos $= "")
						{
							%nameIWinPos = %nameIPos;
							%nameIWinner = %client;
						}
					}
					else if (%client.bl_id == %indexer && !%nonnumeric && %blidWinner $= "")
						%blidWinner = %client;
					else if (%indexer == %i && !%nonnumeric && %indexWinner $= "")
						%indexWinner = %client;
				}
				if (%indexWinner !$= "")
					return %indexWinner;
				if (%blidWinner !$= "")
					return %blidWinner;
				if (%nameWinner !$= "")
					return %nameWinner;
				if (%nameIWinner !$= "")
					return %nameIWinner;
				return "";
			}
			else if (%testVar.getID() == PlayerGroup.getID())
			{
				%group = ClientGroup;
				%count = %group.getCount();
				if (%indexer !$= "" && strPos("0123456789", getSubStr(%indexer, 0, 1)) == -1)
					%nonnumeric = 1;
				for (%i = 0; %i < %count; %i++)
				{
					%client = %group.getObject(%i);
					%nameIPos = striPos(%client.name, %indexer);
					%namePos = strPos(%client.name, %indexer);
					if (%namePos != -1)
					{
						if (%namePos < %nameWinPos || %nameWinPos $= "")
						{
							%nameWinPos = %namePos;
							%nameWinner = %client;
						}
					}
					else if (%nameIPos != -1)
					{
						if (%nameIPos < %nameIWinPos || %nameIWinPos $= "")
						{
							%nameIWinPos = %nameIPos;
							%nameIWinner = %client;
						}
					}
					else if (%client.bl_id == %indexer && !%nonnumeric && %blidWinner $= "")
						%blidWinner = %client;
					else if (%indexer == %i && !%nonnumeric && %indexWinner $= "")
						%indexWinner = %client;
				}
				if (%indexWinner !$= "")
					return %indexWinner.player;
				if (%blidWinner !$= "")
					return %blidWinner.player;
				if (%nameWinner !$= "")
					return %nameWinner.player;
				if (%nameIWinner !$= "")
					return %nameIWinner.player;
				return "";
			}
			else if (%testVar.getID() == MainBrickgroup.getID())
			{
				%group = MainBrickgroup;
				%count = %group.getCount();
				if (%indexer !$= "" && strPos("0123456789", getSubStr(%indexer, 0, 1)) == -1)
					%nonnumeric = 1;
				for (%i = 0; %i < %count; %i++)
				{
					%subgroup = %group.getObject(%i);
					%nameIPos = striPos(%subgroup.name, %indexer);
					%namePos = strPos(%subgroup.name, %indexer);
					if (%namePos != -1)
					{
						if (%namePos < %nameWinPos || %nameWinPos $= "")
						{
							%nameWinPos = %namePos;
							%nameWinner = %subgroup;
						}
					}
					else if (%nameIPos != -1)
					{
						if (%namePos < %nameIWinPos || %nameIWinPos $= "")
						{
							%nameIWinPos = %nameIPos;
							%nameIWinner = %subgroup;
						}
					}
					else if (%subgroup.bl_id == %indexer && !%nonnumeric && %blidWinner $= "")
						%blidWinner = %subgroup;
					else if (%indexer == %i && !%nonnumeric && %indexWinner $= "")
						%indexWinner = %subgroup;
				}
				if (%indexWinner !$= "")
					return %indexWinner;
				if (%blidWinner !$= "")
					return %blidWinner;
				if (%nameWinner !$= "")
					return %nameWinner;
				if (%nameIWinner !$= "")
					return %nameIWinner;
				return "";
			}
			else if (%testVar.getClassName() $= "ScriptObject" && (isFunction(%testVar.class, "getObject")
				|| isFunction(%testVar.superClass, "getObject")))
				return %testVar.getObject(%indexer);
			else if (isFunction(%testVar.getClassName(), "getObject"))
				return %testVar.getObject(%indexer);
			else if (%testVar.getName() !$= "" && isFunction(%testVar.getName(), "getObject"))
				return %testVar.getObject(%indexer);
			else if (%testVar.getClassName() $= "ScriptObject" && %testVar.class $= "MinigameSO")
			{
				if (%indexer < 0 || %indexer >= %testVar.numMembers)
					return "";
				return %testVar.member[%indexer];
			}
			// some other kind of collection - brick (events)
		}
		if (%indexer >= 0 && %indexer < strLen(%testVar))
			return getSubStr(%testVar, %indexer, 1);
	}
	
	// default behavior: no result
	return "";
}

// wip
function setIndexer(%testVar, %indexer, %newValue, %raw)
{
	if (%raw)
	{
		%dotPos = strPos(%indexer, "..");
		if (%dotPos != -1)
		{
			%start = getMax(getSubStr(%indexer, 0, %dotPos), 0);
			%end = getMin(getSubStr(%indexer, %dotPos + 2, strLen(%indexer) - (%dotPos + 2)), strLen(%testValue) - 1);
			return getSubStr(%testValue, 0, %start) @ %newValue @ getSubStr(%testValue, %end + 1, strLen(%testValue) - (%end + 2));
		}
	}
	else
	{
		if (isObject(%testVar))
		{
			// can't edit the ClientGroup
			if (%testVar.getId() == ClientGroup.getID())
				return "";
		}
	}
}

function getValueLength(%testVar)
{
	if (isObject(%testvar))
	{
		if (%testVar.getClassName() $= "ScriptObject" && (isFunction(%testVar.class, "getCount")
			|| isFunction(%testVar.superClass, "getCount")))
			return %testVar.getCount();
		else if (isFunction(%testVar.getClassName(), "getCount"))
			return %testVar.getCount();
		else if (%testVar.getName() !$= "" && isFunction(%testVar.getName(), "getCount"))
			return %testVar.getCount();
		else if (%testVar.getClassName() $= "ScriptObject" && %testVar.class $= "MinigameSO")
			return %testVar.numMembers;
		// some other kind of collection - brick -> events maybe?
	}
	
	// default behavior: string length
	return strLen(%testVar);
}

if (!isObject(PlayerGroup))
	new SimObject(PlayerGroup);
