package Iterators
{
	function SimGroup::add(%group, %obj)
	{
		Parent::add(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimGroup::bringToFront(%group, %obj)
	{
		Parent::bringToFront(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimGroup::clear(%group)
	{
		Parent::clear(%group);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimGroup::pushToBack(%group, %obj)
	{
		Parent::pushToBack(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimGroup::remove(%group, %obj)
	{
		Parent::remove(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}

	function SimSet::add(%group, %obj)
	{
		Parent::add(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimSet::bringToFront(%group, %obj)
	{
		Parent::bringToFront(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimSet::clear(%group)
	{
		Parent::clear(%group);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimSet::pushToBack(%group, %obj)
	{
		Parent::pushToBack(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
	
	function SimSet::remove(%group, %obj)
	{
		Parent::remove(%group, %obj);
		%group.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	}
};
activatePackage("Iterators");

function SimList::add(%list, %obj)
{
	%list.object[%list.count++ - 1] = %obj;
	%list.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
}

function SimList::clear(%list)
{
	%list.count = 0;
	%list.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
}

function SimList::getCount(%list)
{
	return %list.count;
}

function SimList::getObject(%list, %i)
{
	%i = mFloor(%i);
	if (%i < 0 || %i >= %list.count)
		return "";
	return %list.object[%i];
}

function SimList::remove(%list, %obj)
{
	for (%i = 0; %i < %list.count; %i++)
		if (%list.object[%i] $= %obj)
			%shift++;
		else
			%list.object[%i - %shift] = %list.object[%i];
	%list.count -= %shift;
	if (%shift != 0)
		%list.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
	return %shift;
}

function SimList::removeAt(%list, %i)
{
	%i = mFloor(%i);
	if (%i < 0 || %i >= %list.count)
		return;
	for (%i++; %i < %list.count; %i++)
		%list.object[%i - 1] = %list.object[%i];
	%list.count--;
	%list.updateLock = getRandom(0, 65535) << 16 | getRandom(0, 65535);
}

function SimGroup::getEnumerator(%group, %transient)
{
	%enum = new ScriptObject()
	{
		superClass = "Enumerator";
		class = "DefaultEnumerator";
		source = %group;
		currIndex = 0;
	};
	if (%transient || %transient $= "")
		%enum.transient = %enum.schedule(0, "delete");
	return %enum;
}

function SimList::getEnumerator(%list, %transient)
{
	%enum = new ScriptObject()
	{
		superClass = "Enumerator";
		class = "DefaultEnumerator";
		source = %list;
		currIndex = 0;
	};
	if (%transient || %transient $= "")
		%enum.transient = %enum.schedule(0, "delete");
	return %enum;
}

function SimSet::getEnumerator(%set, %transient)
{
	%enum = new ScriptObject()
	{
		superClass = "Enumerator";
		class = "DefaultEnumerator";
		source = %set;
		currIndex = 0;
	};
	if (%transient || %transient $= "")
		%enum.transient = %enum.schedule(0, "delete");
	return %enum;
}

function DefaultEnumerator::moveNext(%enum)
{
	%index = %enum.currIndex;
	%source = %enum.source;
	if (%index == 0)
		%enum.updateLock = %source.updateLock;
	%updateLock = %source.updateLock;
	if (%updateLock !$= "" && (%updateLock | 0) != (%enum.updateLock | 0))
	{
		$error = "Collection was modified; enumeration operation may not execute.";
		error($error);
		return $error;
	}
	if (%index >= %source.getCount())
		return false;
	%enum.currIndex = %index + 1;
	%enum.current = %source.getObject(%index);
	return true;
}

function DefaultEnumerator::reset(%enum)
{
	%enum.currIndex = 0;
	%enum.current = "";
	%enum.sourceTime = 0;
}

function Enumerator::all(%enum, %predicate)
{
	if (!isFunction(%predicate))
		%predicate = createAnonFunction(%predicate);
	if (%predicate $= "")
	{
		$error = "%predicate must be a function.";
		return $error;
	}
	%enum.reset();
	while (%enum.moveNext())
		if (!call(%predicate, %enum.current))
			return false;
	return true;
}

function Enumerator::any(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%predicate $= "")
		return %enum.moveNext();
	while (%enum.moveNext())
		if (call(%predicate, %enum.current))
			return true;
	return false;
}

function Enumerator::average(%enum, %selector)
{
	if (!isFunction(%selector) && %selector !$= "")
		%selector = createAnonFunction(%selector);
	if (%selector $= "")
	{
		$error = "%selector must be a function.";
		return $error;
	}
	%sum = 0;
	%enum.reset();
	while (%enum.moveNext())
	{
		%sum += call(%selector, %enum.current);
		%count++;
	}
	return %sum / %count;
}

function Enumerator::concat(%enum, %concat)
{
	%newEnum = new ScriptObject()
	{
		superClass = "Enumerator";
		class = "ConcatEnumerator";
		source0 = %enum;
		source1 = %concat;
	};
	if (%enum.transient !$= "")
		%newEnum.transient = %newEnum.schedule(0, "delete");
	return %newEnum;
}

function ConcatEnumerator::moveNext(%enum)
{
	if (%enum.source0.moveNext())
	{
		%enum.current = %enum.source0.current;
		return true;
	}
	else if (%enum.source1.moveNext())
	{
		%enum.current = %enum.source1.current;
		return true;
	}
	else
		return false;
}

function ConcatEnumerator::reset(%enum)
{
	%enum.source0.reset();
	%enum.source1.reset();
}

function Enumerator::contains(%enum, %value, %comparer)
{
	if (%comparer !$= "" && !isFunction(%comparer))
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be null or a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%comparer $= "")
		while (%enum.moveNext())
			if (%enum.current $= %value)
				return true;
	else
		while (%enum.moveNext())
			if (call(%comparer, %value, %enum.current) == 0)
				return true;
	return false;
}

function Enumerator::count(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%predicate $= "")
	{
		%count = 0;
		while (%enum.moveNext())
			%count++;
		return %count;
	}
	%count = 0;
	while (%enum.moveNext())
		if (call(%predicate, %enum.current))
			%count++;
	return %count;
}

function Enumerator::defaultIfEmpty(%enum, %value)
{
	%enum.reset();
	if (!%enum.moveNext())
		return %value;
	return %enum;
}

function Enumerator::distinct(%enum, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (!%enum.any())
		return %enum;
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%sorted = %enum.orderBy("%x => %x", %comparer);
	%sorted.moveNext();
	%element = %sorted.current;
	%array[%array++ - 1] = %element;
	while (%sorted.moveNext())
	{
		%next = %sorted.current;
		if (call(%comparer, %element, %next) != 1)
			continue;
		%array[%array++ - 1] = %next;
		%element = %next;
	}
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::elementAt(%enum, %index)
{
	%index = mFloor(%index);
	if (%index < 0)
	{
		$error = "%index was out of range.";
		return $error;
	}
	%enum.reset();
	for (%i = 0; %i <= %index; %i++)
		if (!%enum.moveNext())
		{
			$error = "%index was out of range.";
			return $error;
		}
	return %enum.current;
}

function Enumerator::elementAtOrDefault(%enum, %index)
{
	%index = mFloor(%index);
	if (%index < 0)
		return "";
	%enum.reset();
	for (%i = 0; %i <= %index; %i++)
		if (!%enum.moveNext())
			return "";
	return %enum.current;
}

function Enumerator::except(%enum, %merge, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%enum.reset();
	%merge.reset();
	%list = new ScriptObject() { class = "SimList"; };
	while (%enum.moveNext())
		%list.addUnique(%enum.current, %comparer);
	while (%merge.moveNext())
		%list.remove(%merge.current);
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::first(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%predicate $= "")
	{
		if (!%enum.moveNext())
		{
			$error = "Sequence contains no elements.";
			return $error;
		}
		return %enum.current;
	}
	if (!%enum.moveNext())
	{
		$error = "Sequence contains no elements.";
		return $error;
	}
	if (call(%predicate, %enum.current))
		return %enum.current;
	while (%enum.moveNext())
		if (call(%predicate, %enum.current))
			return %enum.current;
	$error = "Sequence contains no matching element.";
	return $error;
}

function Enumerator::firstOrDefault(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	$error = "";
	%first = %enum.first(%predicate);
	if ($error !$= "")
	{
		$error = "";
		return "";
	}
	return %first;
}

function Enumerator::foreach(%enum, %action)
{
	if (!isFunction(%action))
		%action = createAnonFunction(%action);
	if (%action $= "")
	{
		$error = "%action must be a function.";
		return $error;
	}
	%enum.reset();
	while (%enum.moveNext())
		call(%action, %enum.current);
	return "";
}

function Enumerator::intersect(%enum, %merge, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%enum.reset();
	%merge.reset();
	%set = new ScriptObject() { class = "SimList"; };
	while (%enum.moveNext())
		%set.addUnique(%enum.current, %comparer);
	%list = new ScriptObject() { class = "SimList"; };
	while (%merge.moveNext())
		if (%set.remove(%merge.current))
			%list.add(%merge.current);
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::join(%enum, %merge, %outerSelector, %innerSelector, %resultSelector, %comparer)
{
	if (!isFunction(%outerSelector))
		%innerSelector = createAnonFunction(%outerSelector);
	if (%outerSelector $= "")
	{
		$error = "%outerSelector must be a function.";
		return $error;
	}
	if (!isFunction(%innerSelector))
		%innerSelector = createAnonFunction(%innerSelector);
	if (%innerSelector $= "")
	{
		$error = "%innerSelector must be a function.";
		return $error;
	}
	if (!isFunction(%resultSelector))
		%resultSelector = createAnonFunction(%resultSelector);
	if (%resultSelector $= "")
	{
		$error = "%resultSelector must be a function.";
		return $error;
	}
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%list = new ScriptObject() { class = "SimList"; };
	%enum.reset();
	while (%enum.moveNext())
	{
		%outer = call(%outerSelector, %enum.current);
		%merge.reset();
		while (%merge.moveNext())
		{
			%inner = call(%innerSelector, %merge.current);
			if (call(%comparer, %outer, %inner))
				%list.add(call(%resultSelector, %outer, %inner));
		}
	}
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::last(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%predicate $= "")
	{
		if (!%enum.moveNext())
		{
			$error = "Sequence contains no elements.";
			return $error;
		}
		%curr = %enum.current;
		while (%enum.moveNext())
			%curr = %enum.current;
		return %curr;
	}
	if (!%enum.moveNext())
	{
		$error = "Sequence contains no elements.";
		return $error;
	}
	if (call(%predicate, %enum.current))
	{
		%curr = %enum.current;
		%isMatch = true;
	}
	while (%enum.moveNext())
		if (call(%predicate, %enum.current))
		{
			%curr = %enum.current;
			%isMatch = true;
		}
	if (!%isMatch)
	{
		$error = "Sequence contains no matching element.";
		return $error;
	}
	return %curr;
}

function Enumerator::lastOrDefalt(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	$error = "";
	%last = %enum.last(%predicate);
	if ($error !$= "")
		return "";
	return %last;
}

function Enumerator::max(%enum, %selector)
{
	if (!isFunction(%selector) && %selector !$= "")
	{
		%predicate = createAnonFunction(%selector);
		if (%selector $= "")
		{
			$error = "%selector must be a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%selector $= "")
	{
		if (!%enum.moveNext())
			return "";
		%max = %enum.current;
		while (%enum.moveNext())
			%max = getMax(%max, %enum.current);
		return %max;
	}
	if (!%enum.moveNext())
		return "";
	%max = call(%selector, %enum.current);
	while (%enum.moveNext())
		%max = getMax(%max, call(%selector, %enum.current));
	return %max;
}

function Enumerator::min(%enum, %selector)
{
	if (!isFunction(%selector) && %selector !$= "")
	{
		%selector = createAnonFunction(%selector);
		if (%selector $= "")
		{
			$error = "%selector must be a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%selector $= "")
	{
		if (!%enum.moveNext())
			return "";
		%min = %enum.current;
		while (%enum.moveNext())
			%min = getMin(%min, %enum.current);
		return %min;
	}
	if (!%enum.moveNext())
		return "";
	%min = call(%selector, %enum.current);
	while (%enum.moveNext())
		%min = getMin(%min, call(%selector, %enum.current));
	return %min;
}

function Enumerator::orderBy(%enum, %selector, %comparer)
{
	if (!isFunction(%selector))
		%selector = createAnonFunction(%selector);
	if (%selector $= "")
	{
		$error = "%selector must be a function.";
		return $error;
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	else if (!isFunction(%comparer))
		%comparer = createAnonFunction(%comparer);
	if (%comparer $= "")
	{
		$error = "%comparer must be a function.";
		return $error;
	}
	$elements = 0;
	%enum.reset();
	while (%enum.moveNext())
		$element[$elements++ - 1] = %enum.current;
	mergeSort("(%a, %b) => " @ %comparer @ "(" @ %selector @ "(%a), " @ %selector @ "(%b))");
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < $elements; %i++)
		%list.object[%i] = $element[%i];
	%list.count = $elements;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::orderByDescending(%enum, %selector, %comparer)
{
	if (!isFunction(%selector))
		%selector = createAnonFunction(%selector);
	if (%selector $= "")
	{
		$error = "%selector must be a function.";
		return $error;
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	if (isFunction(%comparer))
		%comparer = "(%a, %b) => " @ %comparer @ "(%b, %a)";
	else
	{
		%arrow = strPos(%comparer, "=>");
		if (%arrow == -1)
		{
			$error = "%comparer must be a function.";
			return $error;
		}
		%args = trim(getSubStr(%comparer, 0, %arrow));
		%code = trim(getSubStr(%comparer, %arrow + 2, strLen(%comparer) - (%arrow + 2)));
		if (strStartsWith(%args, "(") ^ strEndsWith(%args, ")"))
		{
			$error = "%comparer must be a function.";
			return $error;
		}
		else if (strStartsWith(%args, "("))
			%args = getSubStr(%args, 1, strLen(%args) - 2);
		%args = strReplace(%args, ",", " ");
		%words = getWordCount(%args);
		for (%i = 0; %i < %words; %i++)
		{
			%word = getWord(%args, %i);
			if (%word $= "")
				continue;
			if (!strStartsWith(%word, "%"))
			{
				$error = "%comparer must be a function.";
				return $error;
			}
			%argName[%argCount++ - 1] = %word;
		}
		if (%argCount >= 2)
		{
			%temp = %argName0;
			%argName0 = %argName1;
			%argName1 = %temp;
		}
		%args = "(";
		for (%i = 0; %i < %argCount; %i++)
			%args = %args @ (%i == 0 ? "" : ", ") @ %argName[%i];
		%args = %args @ ")";
		%comparer = %args @ " => " @ %code;
	}
	return %enum.orderBy(%selector, %comparer);
}

function Enumerator::reverse(%enum, %index, %count)
{
	%enum.reset();
	while (%enum.moveNext())
		%array[%array++ - 1] = %enum.current;
	if (%index $= "")
	{
		%index = 0;
		%count = %array;
	}
	%end = %index + %count;
	for (%i = %index; %i < %end; %i++)
		%rev[%end - (%i + 1)] = %array[%i];
	for (%i = 0; %i < %count; %i++)
		%array[%index + %i] = %rev[%i];
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::select(%enum, %selector)
{
	if (!isFunction(%selector))
		%selector = createAnonFunction(%selector);
	if (%selector $= "")
	{
		$error = "%selector must be a function.";
		return $error;
	}
	%enum.reset();
	while (%enum.moveNext())
		%array[%array++ - 1] = call(%selector, %enum.current);
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::selobj(%enum, %selector)
{
	if (!isFunction(%selector))
		%selector = createAnonFunction(%selector);
	if (%selector $= "")
	{
		$error = "%selector must be a function.";
		return $error;
	}
	%enum.reset();
	while (%enum.moveNext())
		%array[%array++ - 1] = call(%selector, %enum.current);
	%list = new ScriptObject() { class = "SimList"; };
	%pos = 0;
	for (%i = 0; %i < %array; %i++)
		if (isObject(%array[%i]))
			%list.object[%pos++ - 1] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::sequenceEqual(%enum, %test, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%enum.reset();
	%test.reset();
	while (%enum.moveNext())
	{
		if (!%test.moveNext())
			return false;
		if (call(%comparer, %enum.current, %test.current) != 0)
			return false;
	}
	if (%test.moveNext())
		return false;
	return true;
}

function Enumerator::single(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	%enum.reset();
	if (%predicate $= "")
	{
		if (!%enum.moveNext())
		{
			$error = "Sequence contains no elements.";
			return $error;
		}
		else if (%enum.moveNext())
		{
			$error = "Sequence contains more than one element.";
			return $error;
		}
		else
			return %enum.current;
	}
	if (!%enum.moveNext())
	{
		$error = "Sequence contains no elements.";
		return $error;
	}
	if (call(%predicate, %enum.current))
	{
		%foundMatch = 1;
		%match = %enum.current;
	}
	while (%enum.moveNext())
		if (call(%predicate, %enum.current))
		{
			if (%foundMatch)
			{
				$error = "Sequence contains more than one matching element.";
				return $error;
			}
			%foundMatch = 1;
			%match = %enum.current;
		}
	if (!%foundMatch)
	{
		$error = "Sequence contains no matching elements.";
		return $error;
	}
	return %match;
}

function Enumerator::singleOrDefault(%enum, %predicate)
{
	if (!isFunction(%predicate) && %predicate !$= "")
	{
		%predicate = createAnonFunction(%predicate);
		if (%predicate $= "")
		{
			$error = "%predicate must be a function.";
			return $error;
		}
	}
	$error = "";
	%single = %enum.single(%predicate);
	if ($error !$= "")
	{
		$error = "";
		return "";
	}
	return %single;
}

function Enumerator::skip(%enum, %count)
{
	%enum.reset();
	for (%i = 0; %i < %count; %i++)
		%enum.moveNext();
	while (%enum.moveNext())
		%array[%array++ - 1] = %enum.current;
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::skipWhile(%enum, %predicate)
{
	if (!isFunction(%predicate))
		%predicate = createAnonFunction(%predicate);
	if (%predicate $= "")
	{
		$error = "%predicate must be a function.";
		return $error;
	}
	%enum.reset();
	if (!%enum.moveNext())
		return %enum;
	%index = -1;
	while (call(%predicate, %enum.current, %index++) && %enum.moveNext()) { }
	%array[%array++ - 1] = %enum.current;
	while (%enum.moveNext())
		%array[%array++ - 1] = %enum.current;
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::sum(%enum, %selector)
{
	if (!isFunction(%selector) && %selector !$= "")
		%selector = createAnonFunction(%selector);
	if (%selector $= "")
	{
		$error = "%selector must be a function.";
		return $error;
	}
	%sum = 0;
	%enum.reset();
	while (%enum.moveNext())
	{
		%sum += call(%selector, %enum.current);
		%count++;
	}
	return %sum;
}

function Enumerator::take(%enum, %count)
{
	%enum.reset();
	for (%i = 0; %i < %count; %i++)
	{
		if (!%enum.moveNext())
			break;
		%array[%array++ - 1] = %enum.current;
	}
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::takeWhile(%enum, %predicate)
{
	if (!isFunction(%predicate))
		%predicate = createAnonFunction(%predicate);
	if (%predicate $= "")
	{
		$error = "%predicate must be a function.";
		return $error;
	}
	%enum.reset();
	if (!%enum.moveNext())
		return %enum;
	%index = -1;
	while (call(%predicate, %enum.current, %index++))
	{
		%array[%array++ - 1] = %enum.current;
		%enum.moveNext();
	}
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::toList(%enum)
{
	%enum.reset();
	while (%enum.moveNext())
		%array[%array++ - 1] = %enum.current;
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list;
}

function Enumerator::union(%enum, %merge, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%enum.reset();
	%merge.reset();
	%list = new ScriptObject() { class = "SimList"; };
	while (%enum.moveNext())
		%list.addUnique(%enum.current, %comparer);
	while (%merge.moveNext())
		%list.addUnique(%merge.current, %comparer);
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::where(%enum, %predicate)
{
	if (!isFunction(%predicate))
		%predicate = createAnonFunction(%predicate);
	if (%predicate $= "")
	{
		$error = "%predicate must be a function.";
		return $error;
	}
	%enum.reset();
	%array = 0;
	while (%enum.moveNext())
		if (call(%predicate, %enum.current, %array))
			%array[%array++ - 1] = %enum.current;
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function Enumerator::zip(%enum, %merge, %selector)
{
	if (!isFunction(%selector))
		%selector = createAnonFunction(%selector);
	if (%selector $= "")
	{
		$error = "%selector must be a function.";
		return $error;
	}
	%enum.reset();
	%merge.reset();
	while (%enum.moveNext() && %merge.moveNext())
		%array[%array++ - 1] = call(%selector, %enum.current, %merge.current);
	%list = new ScriptObject() { class = "SimList"; };
	for (%i = 0; %i < %array; %i++)
		%list.object[%i] = %array[%i];
	%list.count = %array;
	if (%enum.transient)
		%list.transient = %list.schedule(0, "delete");
	return %list.getEnumerator(%enum.transient);
}

function RangeEnumerator::moveNext(%enum)
{
	if (%enum.current $= "")
	{
		%enum.current = %enum.start;
		return true;
	}
	if (%enum.current >= %enum.end)
		return false;
	%enum.current += %enum.step;
	return true;
}

function RangeEnumerator::reset(%enum)
{
	%enum.current = "";
}

function range(%start, %end, %step)
{
	if (%step $= "")
		%step = 1;
	if ((%start > %end) ^ (%step < 0))
	{
		%temp = %start;
		%start = %end;
		%end = %temp;
	}
	%enum = new ScriptObject()
	{
		superClass = "Enumerator";
		class = "RangeEnumerator";
		current = %start;
		start = %start;
		end = %end;
		step = %step;
	};
	return %enum;
}

function getContainerBoxSearch(%pos, %box, %mask)
{
	%set = new SimSet();
	initContainerBoxSearch(%pos, %box, %mask);
	for (%obj = containerSearchNext(); isObject(%obj); %obj = containerSearchNext())
		%set.add(%obj);
	%set.deleteSched = %set.schedule(0, "delete");
	return %set;
}

function getContainerRadiusSearch(%pos, %radius, %mask)
{
	%set = new SimSet();
	initContainerRadiusSearch(%pos, %radius, %mask);
	for (%obj = containerSearchNext(); isObject(%obj); %obj = containerSearchNext())
		%set.add(%obj);
	%set.deleteSched = %set.schedule(0, "delete");
	return %set;
}

// anonymous function creator
function createAnonFunction(%code)
{
	%funcName = "anon_" @ sha1(%code);
	if (isFunction(%funcName))
		return %funcName;
	%arrow = strPos(%code, "=>");
	if (%arrow == -1)
		return "";
	%args = trim(getSubStr(%code, 0, %arrow));
	%code = trim(getSubStr(%code, %arrow + 2, strLen(%code) - (%arrow + 2)));
	if (strStartsWith(%args, "("))
	{
		if (!strEndsWith(%args, ")"))
			return "";
	}
	else if (strPos(%args, ",") != -1 || strPos(%args, "%") == -1)
		return "";
	else
		%args = "(" @ %args @ ")";
	if (strStartsWith(%code, "{"))
	{
		if (!strEndsWith(%code, "}"))
			return "";
		%len = strLen(%code);
		for (%i = 0; %i < %len; %i++)
		{
			%char = getSubStr(%code, %i, 1);
			if (%char $= "{")
			{
				%depth++;
				if (%depth <= 0 && %i != 0)
					return "";
			}
			else if (%char $= "}")
			{
				%depth--;
				if (%depth < 0)
					return "";
			}
		}
	}
	else if (strPos(%code, ";") != -1)
		return "";
	else if (strStartsWith(%code, "if"))
		return "";
	else if (strStartsWith(%code, "for"))
		return "";
	else if (strStartsWith(%code, "while"))
		return "";
	else if (strStartsWith(%code, "switch"))
		return "";
	else if (strStartsWith(%code, "package"))
		return "";
	else if (strStartsWith(%code, "function"))
		return "";
	else
		%code = "{return " @ %code @ ";}";
	%code = "function " @ %funcName @ %args @ %code;
	eval(%code);
	if (!isFunction(%funcName))
		return "";
	return %funcName;
}

// TorqueScript merge sort implementation for fast sorting
function mergeSort(%a, %b)
{
	if (%b !$= "")
	{
		%comparer = %b;
		%object = %a;
	}
	else
		%comparer = %a;
	if (!isFunction(%comparer))
		%comparer = createAnonFunction(%comparer);
	if (!isFunction(%comparer))
	{
		%object = %comparer;
		%comparer = "defaultComparer";
	}
	if (%object !$= "" && !isObject(%object))
		return -1;
	
	if (%object !$= "")
	{
		if (%object.getClassName() $= "SimGroup" || %object.getClassName() $= "SimSet"
			|| (%object.getClassName() $= "ScriptObject" && %object.class $= "SimList"))
		{
			%isSimList = 1;
			%count = %object.getCount();
			for (%i = 0; %i < %count; %i++)
				%a0_[%i] = %object.getObject(%i);
		}
		else if (%object.getClassName() $= "ScriptObject"
			&& isFunction(%object.class, "MoveNext") && isFunction(%object.class, "Reset"))
		{
			%pos = -1;
			%object.Reset();
			while (%object.MoveNext())
				%a0_[%pos++] = %object.current;
		}
		else
			return -1;
		
		for (%width = 1; %width < %count; %width *= 2)
		{
			%w = !%w;
			for (%i = 0; %i < %count; %i = %i + %width * 2)
			{
				%left = %i;
				%right = getMin(%i + %width, %count);
				%end = getMin(%i + 2 * %width, %count);
				%l = %left;
				%r = %right;
				for (%j = %left; %j < %end; %j++)
				{
					if (%l < %right && (%r >= %end || call(%comparer, %a[!%w, %l], %a[!%w, %r]) <= 0))
						%a[%w, %j] = %a[!%w, %l++ - 1];
					else
						%a[%w, %j] = %a[!%w, %r++ - 1];
				}
			}
		}
		
		if (%isSimList)
		{
			%object.clear();
			for (%i = 0; %i < %count; %i++)
				%object.add(%a[%w, %i]);
			return %object;
		}
		else
		{
			%object = new ScriptObject()
			{
				class = "SimList";
				count = 0;
			};
			for (%i = 0; %i < %count; %i++)
				%object.add(%a[%w, %i]);
			return %object;
		}
	}
	else
	{
		for (%width = 1; %width < $elements; %width *= 2)
		{
			for (%i = 0; %i < $elements; %i = %i + %width * 2)
			{
				%left = %i;
				%right = getMin(%i + %width, $elements);
				%end = getMin(%i + 2 * %width, $elements);
				%l = %left;
				%r = %right;
				for (%j = %left; %j < %end; %j++)
				{
					if (%l < %right && (%r >= %end || call(%comparer, $element[%l], $element[%r]) <= 0))
						%workArray[%j] = $element[%l++ - 1];
					else
						%workArray[%j] = $element[%r++ - 1];
				}
			}
			for (%i = 0; %i < $elements; %i++)
				$element[%i] = %workArray[%i];
		}
		return -1;
	}
}

// default comparer, compares two values as numbers
function defaultComparer(%a, %b)
{
	return %a < %b ? -1 : (%a > %b ? 1 : 0);
}

// LINQ wrapper functions for SimGroup, SimList, and SimSet
function SimGroup::all(%obj, %predicate) { return %obj.getEnumerator().all(%predicate); }
function SimGroup::any(%obj, %predicate) { return %obj.getEnumerator().any(%predicate); }
function SimGroup::average(%obj, %predicate) { return %obj.getEnumerator().average(%predicate); }
function SimGroup::concat(%obj, %concat) { return %obj.getEnumerator().concat(%concat); }
function SimGroup::contains(%obj, %value, %comparer) { return %obj.getEnumerator().contains(%value, %comparer); }
function SimGroup::count(%obj, %predicate) { return %obj.getEnumerator().count(%predicate); }
function SimGroup::defaultIfEmpty(%obj, %value) { return %obj.getEnumerator().defaultIfEmpty(%value); }
function SimGroup::distinct(%obj, %comparer) { return %obj.getEnumerator().distinct(%comparer); }
function SimGroup::elementAt(%obj, %index) { return %obj.getEnumerator().elementAt(%index); }
function SimGroup::elementAtOrDefault(%obj, %index) { return %obj.getEnumerator().elementAtOrDefault(%index); }
function SimGroup::except(%obj, %merge, %comparer) { return %obj.getEnumerator().except(%merge, %comparer); }
function SimGroup::first(%obj, %predicate) { return %obj.getEnumerator().first(%predicate); }
function SimGroup::firstOrDefault(%obj, %predicate) { return %obj.getEnumerator().firstOrDefault(%predicate); }
function SimGroup::foreach(%obj, %action) { %obj.getEnumerator().foreach(%action); }
function SimGroup::intersect(%obj, %merge, %comparer) { %obj.getEnumerator().intersect(%merge, %comparer); }
function SimGroup::join(%obj, %merge, %outerSelector, %innerSelector, %resultSelector, %comparer) { %obj.join(%merge, %outerSelector, %innerSelector, %resultSelector, %comparer); }
function SimGroup::last(%obj, %predicate) { return %obj.getEnumerator().last(%predicate); }
function SimGroup::lastOrDefault(%obj, %predicate) { return %obj.getEnumerator().lastOrDefault(%predicate); }
function SimGroup::max(%obj, %predicate) { return %obj.getEnumerator().max(%predicate); }
function SimGroup::min(%obj, %predicate) { return %obj.getEnumerator().min(%predicate); }
function SimGroup::orderBy(%obj, %selector, %comparer) { return %obj.getEnumerator().orderBy(%selector, %comparer); }
function SimGroup::orderByDescending(%obj, %selector, %comparer) { return %obj.getEnumerator().orderByDescending(%selector, %comparer); }
function SimGroup::reverse(%obj, %index, %count) { return %obj.getEnumerator().reverse(%index, %count); }
function SimGroup::select(%obj, %selector) { return %obj.getEnumerator().select(%selector); }
function SimGroup::selobj(%obj, %selector) { return %obj.getEnumerator().selobj(%selector); }
function SimGroup::sequenceEqual(%obj, %test, %comparer) { return %obj.getEnumerator().sequenceEqual(%obj, %test, %comparer); }
function SimGroup::single(%obj, %predicate) { return %obj.getEnumerator().single(%predicate); }
function SimGroup::singleOrDefault(%obj, %predicate) { return %obj.getEnumerator().singleOrDefault(%predicate); }
function SimGroup::skip(%obj, %count) { return %obj.getEnumerator().skip(%count); }
function SimGroup::skipWhile(%obj, %predicate) { return %obj.getEnumerator().skipWhile(%predicate); }
function SimGroup::sum(%obj, %selector) { return %obj.getEnumerator().sum(%selector); }
function SimGroup::take(%obj, %count) { return %obj.getEnumerator().take(%count); }
function SimGroup::takeWhile(%obj, %predicate) { return %obj.getEnumerator().takeWhile(%predicate); }
function SimGroup::union(%obj, %merge, %comparer) { return %obj.getEnumerator().union(%merge, %comparer); }
function SimGroup::where(%obj, %predicate) { return %obj.getEnumerator().where(%predicate); }
function SimGroup::zip(%obj, %merge, %selector) { return %obj.getEnumerator().zip(%merge, %selector); }

function SimGroup::toList(%obj)
{
	%list = new ScriptObject() { class = "SimList"; };
	%list.count = %obj.getCount();
	for (%i = 0; %i < %list.count; %i++)
		%list.object[%i] = %obj.getObject(%i);
	return %list;
}

function SimGroup::addUnique(%obj, %toAdd, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%count = %obj.getCount();
	for (%i = 0; %i < %count; %i++)
		if (call(%comparator, %toAdd, %obj.getObject(%i)) == 0)
			return false;
	%obj.add(%toAdd);
	return true;
}

function SimList::all(%obj, %predicate) { return %obj.getEnumerator().all(%predicate); }
function SimList::any(%obj, %predicate) { return %obj.getEnumerator().any(%predicate); }
function SimList::average(%obj, %predicate) { return %obj.getEnumerator().average(%predicate); }
function SimList::concat(%obj, %concat) { return %obj.getEnumerator().concat(%concat); }
function SimList::contains(%obj, %value, %comparer) { return %obj.getEnumerator().contains(%value, %comparer); }
function SimList::count(%obj, %predicate) { return %obj.getEnumerator().count(%predicate); }
function SimList::defaultIfEmpty(%obj, %value) { return %obj.getEnumerator().defaultIfEmpty(%value); }
function SimList::distinct(%obj, %comparer) { return %obj.getEnumerator().distinct(%comparer); }
function SimList::elementAt(%obj, %index) { return %obj.getEnumerator().elementAt(%index); }
function SimList::elementAtOrDefault(%obj, %index) { return %obj.getEnumerator().elementAtOrDefault(%index); }
function SimList::except(%obj, %merge, %comparer) { return %obj.getEnumerator().except(%merge, %comparer); }
function SimList::first(%obj, %predicate) { return %obj.getEnumerator().first(%predicate); }
function SimList::firstOrDefault(%obj, %predicate) { return %obj.getEnumerator().firstOrDefault(%predicate); }
function SimList::foreach(%obj, %action) { %obj.getEnumerator().foreach(%action); }
function SimList::intersect(%obj, %merge, %comparer) { %obj.getEnumerator().intersect(%merge, %comparer); }
function SimList::join(%obj, %merge, %outerSelector, %innerSelector, %resultSelector, %comparer) { %obj.join(%merge, %outerSelector, %innerSelector, %resultSelector, %comparer); }
function SimList::last(%obj, %predicate) { return %obj.getEnumerator().last(%predicate); }
function SimList::lastOrDefault(%obj, %predicate) { return %obj.getEnumerator().lastOrDefault(%predicate); }
function SimList::max(%obj, %predicate) { return %obj.getEnumerator().max(%predicate); }
function SimList::min(%obj, %predicate) { return %obj.getEnumerator().min(%predicate); }
function SimList::orderBy(%obj, %selector, %comparer) { return %obj.getEnumerator().orderBy(%selector, %comparer); }
function SimList::orderByDescending(%obj, %selector, %comparer) { return %obj.getEnumerator().orderByDescending(%selector, %comparer); }
function SimList::reverse(%obj, %index, %count) { return %obj.getEnumerator().reverse(%index, %count); }
function SimList::select(%obj, %selector) { return %obj.getEnumerator().select(%selector); }
function SimList::selobj(%obj, %selector) { return %obj.getEnumerator().selobj(%selector); }
function SimList::sequenceEqual(%obj, %test, %comparer) { return %obj.getEnumerator().sequenceEqual(%obj, %test, %comparer); }
function SimList::single(%obj, %predicate) { return %obj.getEnumerator().single(%predicate); }
function SimList::singleOrDefault(%obj, %predicate) { return %obj.getEnumerator().singleOrDefault(%predicate); }
function SimList::skip(%obj, %count) { return %obj.getEnumerator().skip(%count); }
function SimList::skipWhile(%obj, %predicate) { return %obj.getEnumerator().skipWhile(%predicate); }
function SimList::sum(%obj, %selector) { return %obj.getEnumerator().sum(%selector); }
function SimList::take(%obj, %count) { return %obj.getEnumerator().take(%count); }
function SimList::takeWhile(%obj, %predicate) { return %obj.getEnumerator().takeWhile(%predicate); }
function SimList::union(%obj, %merge, %comparer) { return %obj.getEnumerator().union(%merge, %comparer); }
function SimList::where(%obj, %predicate) { return %obj.getEnumerator().where(%predicate); }
function SimList::zip(%obj, %merge, %selector) { return %obj.getEnumerator().zip(%merge, %selector); }

function SimList::toList(%obj)
{
	%list = new ScriptObject() { class = "SimList"; };
	%list.count = %obj.getCount();
	for (%i = 0; %i < %list.count; %i++)
		%list.object[%i] = %obj.getObject(%i);
	return %list;
}

function SimList::addUnique(%obj, %toAdd, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%count = %obj.getCount();
	for (%i = 0; %i < %count; %i++)
		if (call(%comparator, %toAdd, %obj.getObject(%i)) == 0)
			return false;
	%obj.add(%toAdd);
	return true;
}

function SimSet::all(%obj, %predicate) { return %obj.getEnumerator().all(%predicate); }
function SimSet::any(%obj, %predicate) { return %obj.getEnumerator().any(%predicate); }
function SimSet::average(%obj, %predicate) { return %obj.getEnumerator().average(%predicate); }
function SimSet::concat(%obj, %concat) { return %obj.getEnumerator().concat(%concat); }
function SimSet::contains(%obj, %value, %comparer) { return %obj.getEnumerator().contains(%value, %comparer); }
function SimSet::count(%obj, %predicate) { return %obj.getEnumerator().count(%predicate); }
function SimSet::defaultIfEmpty(%obj, %value) { return %obj.getEnumerator().defaultIfEmpty(%value); }
function SimSet::distinct(%obj, %comparer) { return %obj.getEnumerator().distinct(%comparer); }
function SimSet::elementAt(%obj, %index) { return %obj.getEnumerator().elementAt(%index); }
function SimSet::elementAtOrDefault(%obj, %index) { return %obj.getEnumerator().elementAtOrDefault(%index); }
function SimSet::except(%obj, %merge, %comparer) { return %obj.getEnumerator().except(%merge, %comparer); }
function SimSet::first(%obj, %predicate) { return %obj.getEnumerator().first(%predicate); }
function SimSet::firstOrDefault(%obj, %predicate) { return %obj.getEnumerator().firstOrDefault(%predicate); }
function SimSet::foreach(%obj, %action) { %obj.getEnumerator().foreach(%action); }
function SimSet::intersect(%obj, %merge, %comparer) { %obj.getEnumerator().intersect(%merge, %comparer); }
function SimSet::join(%obj, %merge, %outerSelector, %innerSelector, %resultSelector, %comparer) { %obj.join(%merge, %outerSelector, %innerSelector, %resultSelector, %comparer); }
function SimSet::last(%obj, %predicate) { return %obj.getEnumerator().last(%predicate); }
function SimSet::lastOrDefault(%obj, %predicate) { return %obj.getEnumerator().lastOrDefault(%predicate); }
function SimSet::max(%obj, %predicate) { return %obj.getEnumerator().max(%predicate); }
function SimSet::min(%obj, %predicate) { return %obj.getEnumerator().min(%predicate); }
function SimSet::orderBy(%obj, %selector, %comparer) { return %obj.getEnumerator().orderBy(%selector, %comparer); }
function SimSet::orderByDescending(%obj, %selector, %comparer) { return %obj.getEnumerator().orderByDescending(%selector, %comparer); }
function SimSet::reverse(%obj, %index, %count) { return %obj.getEnumerator().reverse(%index, %count); }
function SimSet::select(%obj, %selector) { return %obj.getEnumerator().select(%selector); }
function SimSet::selobj(%obj, %selector) { return %obj.getEnumerator().selobj(%selector); }
function SimSet::sequenceEqual(%obj, %test, %comparer) { return %obj.getEnumerator().sequenceEqual(%obj, %test, %comparer); }
function SimSet::single(%obj, %predicate) { return %obj.getEnumerator().single(%predicate); }
function SimSet::singleOrDefault(%obj, %predicate) { return %obj.getEnumerator().singleOrDefault(%predicate); }
function SimSet::skip(%obj, %count) { return %obj.getEnumerator().skip(%count); }
function SimSet::skipWhile(%obj, %predicate) { return %obj.getEnumerator().skipWhile(%predicate); }
function SimSet::sum(%obj, %selector) { return %obj.getEnumerator().sum(%selector); }
function SimSet::take(%obj, %count) { return %obj.getEnumerator().take(%count); }
function SimSet::takeWhile(%obj, %predicate) { return %obj.getEnumerator().takeWhile(%predicate); }
function SimSet::union(%obj, %merge, %comparer) { return %obj.getEnumerator().union(%merge, %comparer); }
function SimSet::where(%obj, %predicate) { return %obj.getEnumerator().where(%predicate); }
function SimSet::zip(%obj, %merge, %selector) { return %obj.getEnumerator().zip(%merge, %selector); }

function SimSet::toList(%obj)
{
	%list = new ScriptObject() { class = "SimList"; };
	%list.count = %obj.getCount();
	for (%i = 0; %i < %list.count; %i++)
		%list.object[%i] = %obj.getObject(%i);
	return %list;
}

function SimSet::addUnique(%obj, %toAdd, %comparer)
{
	if (!isFunction(%comparer) && %comparer !$= "")
	{
		%comparer = createAnonFunction(%comparer);
		if (%comparer $= "")
		{
			$error = "%comparer must be a function.";
			return $error;
		}
	}
	if (%comparer $= "")
		%comparer = "defaultComparer";
	%count = %obj.getCount();
	for (%i = 0; %i < %count; %i++)
		if (call(%comparator, %toAdd, %obj.getObject(%i)) == 0)
			return false;
	%obj.add(%toAdd);
	return true;
}

function strStartsWith(%haystack, %needle) { return strPos(%haystack, %needle) == 0; }
function striStartsWith(%haystack, %needle) { return striPos(%haystack, %needle) == 0; }
function strEndsWith(%haystack, %needle) { %target = strLen(%haystack) - strLen(%needle); return strPos(%haystack, %needle, %target) == %target; }
function striEndsWith(%haystack, %needle) { %target = strLen(%haystack) - strLen(%needle); return striPos(%haystack, %needle, %target) == %target; }
