// These variables can all be edited either in the server prefs file, or using eval directly.
// They should not be changed here, as these values represent only the default values.
// Values changed here will not overwrite values that already exist in the server prefs file.

// Use: Loads an ExtEval_* color scheme.
if ($Pref::Server::ExtEval::SchemeName $= "")
	$Pref::Server::ExtEval::SchemeName = "Default";

// Use: Enables ExtEval syntax extensions, as documented in description.txt.
if ($Pref::Server::ExtEval::SyntaxExtensions $= "")
	$Pref::Server::ExtEval::SyntaxExtensions = 1;

// Use: Changes what characters can be used in chat to execute code.
// Example: If this field is +$^, then +, $, and ^ can all be used at the start of chat to execute code.
if ($Pref::Server::ExtEval::ControlChars $= "")
	$Pref::Server::ExtEval::ControlChars = "+";

// Use: Activate Direct Effect mode, allowing assignments to cause direct effects.
// Example: /eval %pos = %hitPos; will cause the user to teleport to the object they are looking at.
if ($Pref::Server::ExtEval::DirectEffectMode $= "")
	$Pref::Server::ExtEval::DirectEffectMode = 1;

// Use: Allows partial expressions, and displays their result.
// Example: /eval 2 + 3 * 4 will announce "14".
if ($Pref::Server::ExtEval::PrintIncompleteCode $= "")
	$Pref::Server::ExtEval::PrintIncompleteCode = 1;

// Use: Displays any text echoed to the console.
if ($Pref::Server::ExtEval::EchoConsole $= "")
	$Pref::Server::ExtEval::EchoConsole = 1;

// Use: Displays attempted eval usage from people without permission to use eval.
// Note: If NoChatIllegalAttempts is turned off, players can abuse this as a way to avoid chat restrictions.
if ($Pref::Server::ExtEval::DisplayIllegalAttempts $= "")
	$Pref::Server::ExtEval::DisplayIllegalAttempts = 0;

// Use: If DisplayIllegalAttempts is enabled, attempts are shown only to superadmins.
if ($Pref::Server::ExtEval::NoChatIllegalAttempts $= "")
	$Pref::Server::ExtEval::NoChatIllegalAttempts = 1;

// Use: Always allow superadmins to use eval.
// !!DANGER!! Eval can modify *anything*. Granting eval permissions implicitly grants ALL permissions.
// Clients you grant eval permissions to can kick all the users, change what add-ons are enabled,
// create new files, delete any file in the Blockland directory, crash the server, and more.
// DO NOT ENABLE THIS UNLESS YOU ARE 100% SURE.
if ($Pref::Server::ExtEval::AllowSAs $= "")
	$Pref::Server::ExtEval::AllowSAs = 0;
