function loadDefaultScheme()
{
	deleteVariables("$ExtEval_Scheme*");
	$Pref::Server::ExtEval::SchemeName = "Default";
	$ExtEval_SchemeFormat_EvalReject = "<c:brackets>[<c:namefail><f:client.name><c:brackets>] > <c:evalreject><r:<f:eval>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_EvalWin = "<c:brackets>[<is.field:elev:<c:nameelev><f:elev.name><c:CCC> <gt> ><c:namewin><f:client.name><c:brackets>] > <c:evalwin><r:<f:eval>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_EvalPreFail = "<c:brackets>[<is.field:elev:<c:nameelev><f:elev.name><c:CCC> <gt> ><c:namewin><f:client.name><c:brackets>] > <is.true:evalfailend:<c:evalfailend><r:<f:eval>:<lt>:<lt>\cr>:<c:evalwin><r:<f:evalwin>:<lt>:<lt>\cr><c:evalfail><r:<f:evalfail>:<lt>:<lt>\cr>>";
	$ExtEval_SchemeFormat_EvalFail = "<c:brackets>[<is.field:elev:<c:nameelev><f:elev.name><c:CCC> <gt> ><c:namewin><f:client.name><c:brackets>] > <c:evalfail><r:<f:eval>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_EvalMultiline = "<c:brackets>[<is.field:elev:<c:nameelev><f:elev.name><c:CCC> <gt> ><c:namewin><f:client.name><c:brackets>] > <c:evalwin><r:<f:eval>:<lt>:<lt>\cr>\c6 ...";
	$ExtEval_SchemeFormat_EvalAnnounce = "\c5CONSOLE:<color:FFFFFF> <r:<f:value>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_EvalErrorAnnounce = "\c5CONSOLE: <color:FFBA00>ERROR<color:FFFFFF>: <r:<f:value>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_EvalConsoleAnnounce = "\c5CONSOLE:<color:FFFFFF> <r:<f:value>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_EvalConsoleLine = "  <color:BABABA><r:<f:value>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_PEvalWin = "<c:brackets>[<c:namewin><f:client.name><c:brackets>] ==> <c:evalwin><r:<f:eval>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_PEvalPreFail = "<c:brackets>[<c:namewin><f:client.name><c:brackets>] ==> <is.true:evalfailend:<c:evalfailend><r:<f:eval>:<lt>:<lt>\cr>:<c:evalwin><r:<f:evalwin>:<lt>:<lt>\cr><c:evalfail><r:<f:evalfail>:<lt>:<lt>\cr>>";
	$ExtEval_SchemeFormat_PEvalFail = "<c:brackets>[<c:namewin><f:client.name><c:brackets>] ==> <c:evalfail><r:<f:eval>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_MsgElevOnNoDisplay = "\c6You can only elevate eval attempts when unauthorized attempts are displayed!";
	$ExtEval_SchemeFormat_MsgElevOnNoDisplayHint = "\c6Eval $Pref::Server::ExtEval::DisplayIllegalAttempts = 1; to show unauthorized attempts to eval.";
	$ExtEval_SchemeFormat_MsgElevOnRecent = "\c6That person attempted to eval code recently - please check over their code again/more thoroughly.";
	$ExtEval_SchemeFormat_MsgElevReject = "\c6You can't elevate anyone's eval!";
	$ExtEval_SchemeFormat_MsgEmptyEval = "\c6You have to put in something to evaluate!";
	$ExtEval_SchemeFormat_MsgNeverEvalled = "\c6That person has never used eval!";
	$ExtEval_SchemeFormat_MsgPEvalDeleteLine = "\c6Removed line <f:line> (\"<color:808080><r:<f:eval>:<lt>:<lt>\cr>\c6\")";
	$ExtEval_SchemeFormat_MsgPEvalLine = "\c6[<color:808080><padleft:<f:line>:4:0>\c6]: <r:<f:eval>:<lt>:<lt>\cr>";
	$ExtEval_SchemeFormat_MsgPEvalPrefix = "\c6<is.false:count:No permanent evals have been made.:Permanent eval list<colon>>";
	$ExtEval_SchemeFormat_MsgTargetNotFound = "\c6Unable to find \"<f:target>\"!";
	$ExtEval_SchemeColor_Brackets = "\c6";
	$ExtEval_SchemeColor_NameWin = "<c:9999FF>";
	$ExtEval_SchemeColor_NameFail = "<c:FF9999>";
	$ExtEval_SchemeColor_NameElev = "<c:99FF99>";
	$ExtEval_SchemeColor_EvalWin = "<c:99FF99>";
	$ExtEval_SchemeColor_EvalFail = "<c:FF9999>";
	$ExtEval_SchemeColor_EvalFailEnd = "<c:FFFF99>";
	$ExtEval_SchemeColor_EvalReject = "<c:FF4040>";
}

function loadExtEvalScheme(%scheme)
{
	if (%scheme $= "Default")
	{
		loadDefaultScheme();
		return 1;
	}
	%file = "Add-Ons/ExtEval_" @ %scheme @ "/Scheme.txt";
	if (!isFile(%file))
		return 0;
	loadDefaultScheme();
	%read = new FileObject();
	%read.openForRead(%file);
	while (!%read.isEOF())
	{
		if (!%reparse)
		{
			%lineNum++;
			%line = %read.readLine();
		}
		%reparse = 0;
		%category = 0;
		if (trim(%line) $= "")
			continue;
		%pos = strPos(%line, "=");
		if (%pos == -1)
		{
			%pos = strPos(%line, ":");
			%category = 1;
		}
		if (%pos == -1)
		{
			%error = "invalid line \"" @ %line @ "\" on line " @ %lineNum;
			break;
		}
		%name = getSubStr(%line, 0, %pos);
		if (%category)
			%name = lTrim(%name);
		else
			%name = trim(%name);
		if (%name $= "")
		{
			%error = "missing identifier on line " @ %lineNum;
			break;
		}
		%len = strLen(%name);
		%legal = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		for (%i = 0; %i < %len; %i++)
		{
			%char = getSubStr(%name, %i, 1);
			if (striPos(%legal, %char) == -1)
			{
				%badChar = 1;
				break;
			}
		}
		if (%badChar)
		{
			%error = "illegal identifier \"" @ %name @ "\" on line " @ %lineNum;
			break;
		}
		%index = %lines++ - 1;
		if (%category)
		{
			%lineAct[%index] = "category";
			%lineName[%index] = %name;
			%line = getSubStr(%line, %pos + 1, strLen(%line) - (%pos + 1));
			%reparse = 1;
		}
		else
		{
			%lineAct[%index] = "field";
			%lineName[%index] = %name;
			%lineValue[%index] = getSubStr(%line, %pos + 1, strLen(%line) - (%pos + 1));
		}
	}
	%read.close();
	%read.delete();
	if (%error !$= "")
	{
		echo("\c2" @ fileBase(filePath(%file)) @ "\c1 - \c0" @ %error);
		return 0;
	}
	for (%i = 0; %i < %lines; %i++)
	{
		%act = %lineAct[%i];
		if (%act $= "category")
			%category = %lineName[%i];
		else if (%act $= "field")
			$ExtEval_Scheme[%category, %lineName[%i]] = %lineValue[%i];
	}
	%scheme = fileBase(filePath(%file));
	%scheme = getSubStr(%scheme, 6, strLen(%scheme) - 6);
	$Pref::Server::ExtEval::SchemeName = %scheme;
	return 1;
}

function ExtEval_SetField(%field, %value)
{
	if ($ExtEval_Field_[%field] $= "")
	{
		if (%value $= "")
			return;
		$ExtEval_Field[$ExtEval_FieldNum++ - 1] = %field;
	}
	else
	{
		if (%value $= "")
		{
			for (%i = 0; %i < $ExtEval_FieldNum; %i++)
				if ($ExtEval_Field[%i] $= %field)
					%shift++;
				else
					$ExtEval_Field[%i - %shift] = $ExtEval_Field[%i];
			$ExtEval_FieldNum -= %shift;
			return;
		}
	}
	$ExtEval_Field_[%field] = %value;
}

function ExtEval_ClearFields()
{
	for (%i = 0; %i < $ExtEval_FieldNum; %i++)
	{
		$ExtEval_Field_[$ExtEval_Field[%i]] = "";
		$ExtEval_Field[%i] = "";
	}
	$ExtEval_FieldNum = 0;
}

function ExtEval_Announce(%client, %value)
{
	if (isObject(AnonFns) && AnonFns._[%value] !$= "" && $Pref::Server::ExtEval::SyntaxExtensions)
		%value = AnonFns._[%value];
	ExtEval_SetField("client", %client);
	ExtEval_SetField("value", %value);
	if (%client.evalWhisper)
		messageAdminsAndClient('', ExtEval_FromFormat("EvalAnnounce"), %client);
	else
		messageAll('', ExtEval_FromFormat("EvalAnnounce"));
}

function ExtEval_SilentAnnounce(%client, %value)
{
	if (isObject(AnonFns) && AnonFns._[%value] !$= "" && $Pref::Server::ExtEval::SyntaxExtensions)
		%value = AnonFns._[%value];
	ExtEval_SetField("client", %client);
	ExtEval_SetField("value", %value);
	messageAdminsAndClient('', ExtEval_FromFormat("EvalAnnounce"), %client);
}

function ExtEval_AnnounceError(%client, %value)
{
	ExtEval_SetField("client", %client);
	ExtEval_SetField("value", %value);
	if (%client.evalWhisper)
		messageAdminsAndClient('', ExtEval_FromFormat("EvalErrorAnnounce"), %client);
	else
		messageAll('', ExtEval_FromFormat("EvalErrorAnnounce"));
}

function ExtEval_FromFormat(%format, %suppressAutoclear)
{
	return ExtEval_Format($ExtEval_SchemeFormat_[%format], %suppressAutoclear);
}

function ExtEval_Format(%text, %suppressAutoclear)
{
	%pos = 0;
	%len = strLen(%text);
	while (%pos < %len)
	{
		%invalid = 0;
		%startPos = strPos(%text, "<", %pos);
		if (%startPos == -1)
		{
			if (!%suppressAutoclear)
				ExtEval_ClearFields();
			return %text;
		}
		%pos = %startPos + 1;
		%cPos = %pos;
		%depth = 1;
		while (%depth > 0 && %pos < %len)
		{
			%nextStart = strPos(%text, "<", %pos);
			%endPos = strPos(%text, ">", %pos);
			if (%endPos == -1)
				break;
			if (%nextStart != -1 && %nextStart < %endPos)
			{
				%pos = %nextStart + 1;
				%depth++;
			}
			else
			{
				%pos = %endPos + 1;
				%depth--;
			}
		}
		%pos = %cPos;
		if (%depth != 0)
			continue;
		%tag = getSubStr(%text, %pos, %endPos - %pos);
		%nextStart = strPos(%tag, "<");
		%delimiter = strPos(%tag, ":");
		if (%delimiter != -1 && %nextStart != -1 && %nextStart < %delimiter)
			continue;
		if (%delimiter != -1)
		{
			%name = getSubStr(%tag, 0, %delimiter);
			%tag = getSubStr(%tag, %delimiter + 1, strLen(%tag) - (%delimiter + 1));
		}
		else
		{
			%name = %tag;
			%tag = "";
		}
		%fieldPos = strPos(%name, ".");
		if (%fieldPos != -1)
		{
			%field = getSubStr(%name, %fieldPos + 1, strLen(%name) - (%fieldPos + 1));
			%name = getSubStr(%name, 0, %fieldPos);
		}
		if (%name $= "" || (%fieldPos != -1 && %field $= "") || (%delimiter != -1 && %tag $= ""))
			continue;
		%func = "ExtFormat_Tag" @ %name;
		if (%delimiter == -1 && $ExtFormat_TagConst[%name] !$= "")
			%replace = $ExtFormat_TagConst[%name];
		else if (isFunction(%func))
		{
			if (%fieldPos != -1)
				%replace = call(%func, %field, %tag);
			else
				%replace = call(%func, %tag);
		}
		else
		{
			%pos = %endPos + 1;
			continue;
		}
		%text = getSubStr(%text, 0, %pos - 1) @ %replace
			@ getSubStr(%text, %endPos + 1, strLen(%text) - (%endPos + 1));
		%pos += strLen(%replace) - 1;
		%len = strLen(%text);
	}
	if (!%suppressAutoclear)
		ExtEval_ClearFields();
	return %text;
}

$ExtFormat_TagConstColon = ":";
$ExtFormat_TagConstGT = ">";
$ExtFormat_TagConstLT = "<";

function ExtFormat_TagC(%tag)
{
	return ExtFormat_TagColor(%tag);
}

function ExtFormat_TagColor(%tag)
{
	if ($ExtEval_SchemeColor_[%tag] !$= "")
	{
		%color = $ExtEval_SchemeColor_[%tag];
		if ((strStartsWith(%color, "<c:") || strStartsWith(%color, "<color:")) && strEndsWith(%color, ">"))
		{
			%pos = strPos(%color, ":") + 1;
			%tag = getSubStr(%color, %pos, strLen(%color) - (%pos + 1));
		}
		else
			return $ExtEval_SchemeColor_[%tag];
	}
	if ($X11Color[%tag] !$= "")
		return "<color:" @ $X11Color[%tag] @ ">";
	%len = strLen(%tag);
	%hex = "0123456789ABCDEF";
	for (%i = 0; %i < %len; %i++)
		if (striPos(%hex, getSubStr(%tag, %i, 1)) == -1)
			return "";
	if (%len == 3)
	{
		for (%i = 0; %i < %len; %i++)
		{
			%char = getSubStr(%tag, %i, 1);
			%out = %out @ %char @ %char;
		}
		%tag = %out;
		%len = 6;
	}
	if (%len == 6 || %len == 8)
		return "<color:" @ %tag  @ ">";
	else
		return "";
}

function ExtFormat_TagF(%tag)
{
	return ExtFormat_TagField(%tag);
}

function ExtFormat_TagField(%tag)
{
	%lPos = 0;
	%len = strLen(%tag);
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%tag, %i, 1);
		if (%char $= ".")
		{
			%arg[%args++ - 1] = getSubStr(%tag, %lPos, %i - %lPos);
			%lPos = %i + 1;
		}
	}
	if (%lPos != %len)
		%arg[%args++ - 1] = getSubStr(%tag, %lPos, %len - %lPos);
	if ($ExtEval_Field_[%arg0] $= "")
		return "";
	for (%i = 1; %i < %args; %i++)
	{
		%arg = %arg[%i];
		if (%arg $= "")
			return "";
		%len = strLen(%arg);
		%allowed = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_";
		for (%j = 0; %j < %len; %j++)
		{
			%char = getSubStr(%arg, %j, 1);
			if (striPos(%allowed, %char) == -1)
				return "";
			if (%j == 0)
				%allowed = %allowed @ "1234567890";
		}
	}
	%field = $ExtEval_Field_[%arg0];
	for (%i = 1; %i < %args; %i++)
	{
		if (!isObject(%field))
			return "";
		%field = eval("return " @ %field.getID() @ "." @ %arg[%i] @ ";");
	}
	return %field;
}

function ExtFormat_TagIs(%arg, %tag)
{
	if (%tag $= "")
		return "";
	%lPos = 0;
	%len = strLen(%tag);
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%tag, %i, 1);
		if (%char $= "<")
			%depth++;
		else if (%char $= ">")
			%depth--;
		else if (%char $= ":" && %depth == 0)
		{
			%arg[%args++ - 1] = getSubStr(%tag, %lPos, %i - %lPos);
			%lPos = %i + 1;
		}
	}
	if (%lPos != %len)
		%arg[%args++ - 1] = getSubStr(%tag, %lPos, %len - %lPos);
	if (%arg1 $= %arg2)
		return ExtEval_Format(%arg1, 1);
	%condition = %arg0;
	%ifTrue = %arg1;
	%ifFalse = %arg2;
	%func = "ExtFormat_Is" @ %arg;
	if (isFunction(%func))
		%result = call(%func, %condition);
	else
		%result = 0;
	if (%result)
		return ExtEval_Format(%ifTrue, 1);
	else
		return ExtEval_Format(%ifFalse, 1);
}

function ExtFormat_TagPadLeft(%tag)
{
	if (%tag $= "")
		return "";
	%lPos = 0;
	%len = strLen(%tag);
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%tag, %i, 1);
		if (%char $= "<")
			%depth++;
		else if (%char $= ">")
			%depth--;
		else if (%char $= ":" && %depth == 0)
		{
			%arg[%args++ - 1] = getSubStr(%tag, %lPos, %i - %lPos);
			%lPos = %i + 1;
		}
	}
	if (%lPos != %len)
		%arg[%args++ - 1] = getSubStr(%tag, %lPos, %len - %lPos);
	if (%args == 2)
		%arg[%args++ - 1] = " ";
	if (%args < 3)
		return "";
	%arg0 = ExtEval_Format(%arg0, 1);
	if (strLen(%arg0) >= %arg1)
		return %arg0;
	%arg2 = ExtEval_Format(%arg2, 1);
	%copy = mCeil((%arg1 - strLen(%arg0)) / strLen(%arg2));
	for (%i = 0; %i < %copy; %i++)
		%arg0 = %arg2 @ %arg0;
	%arg0 = getSubStr(%arg0, strLen(%arg0) - %arg1, %arg1);
}

function ExtFormat_TagPadRight(%tag)
{
	if (%tag $= "")
		return "";
	%lPos = 0;
	%len = strLen(%tag);
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%tag, %i, 1);
		if (%char $= "<")
			%depth++;
		else if (%char $= ">")
			%depth--;
		else if (%char $= ":" && %depth == 0)
		{
			%arg[%args++ - 1] = getSubStr(%tag, %lPos, %i - %lPos);
			%lPos = %i + 1;
		}
	}
	if (%lPos != %len)
		%arg[%args++ - 1] = getSubStr(%tag, %lPos, %len - %lPos);
	if (%args == 2)
		%arg[%args++ - 1] = " ";
	if (%args < 3)
		return "";
	%arg0 = ExtEval_Format(%arg0, 1);
	if (strLen(%arg0) >= %arg1)
		return %arg0;
	%arg2 = ExtEval_Format(%arg2, 1);
	%copy = mCeil((%arg1 - strLen(%arg0)) / strLen(%arg2));
	for (%i = 0; %i < %copy; %i++)
		%arg0 = %arg0 @ %arg2;
	%arg0 = getSubStr(%arg0, 0, %arg1);
}

function ExtFormat_TagR(%tag)
{
	ExtFormat_TagReplace(%tag);
}

function ExtFormat_TagReplace(%tag)
{
	if (%tag $= "")
		return "";
	%lPos = 0;
	%len = strLen(%tag);
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%tag, %i, 1);
		if (%char $= "<")
			%depth++;
		else if (%char $= ">")
			%depth--;
		else if (%char $= ":" && %depth == 0)
		{
			%arg[%args++ - 1] = getSubStr(%tag, %lPos, %i - %lPos);
			%lPos = %i + 1;
		}
	}
	if (%lPos != %len)
		%arg[%args++ - 1] = getSubStr(%tag, %lPos, %len - %lPos);
	if (%args < 3)
		return "";
	return strReplace(ExtEval_Format(%arg0, 1), ExtEval_Format(%arg1, 1), ExtEval_Format(%arg2, 1));
}

function ExtFormat_IsEqual(%field)
{
	%pos = strPos(%field, ",");
	if (%pos == -1)
		return 0;
	%field0 = getSubStr(%field, 0, %pos);
	%field1 = getSubStr(%field, %pos + 1, strLen(%field) - (%pos + 1));
	return ExtFormat_TagField(%field0) == ExtFormat_TagField(%field1);
}

function ExtFormat_IsFalse(%field)
{
	return ExtFormat_TagField(%field) == 0;
}

function ExtFormat_IsField(%field)
{
	return ExtFormat_TagField(%field) !$= "";
}

function ExtFormat_IsObject(%field)
{
	return isObject(ExtFormat_TagField(%field));
}

function ExtFormat_IsTrue(%field)
{
	return ExtFormat_TagField(%field) != 0;
}
