// load ExtEval preferences
exec("./prefs.cs");

package ExtEval
{
	function createAnonFunction(%code)
	{
		%anon = Parent::createAnonFunction(%code);
		if (%anon $= "")
			return %anon;
		if (!isObject(AnonFns))
			new SimObject(AnonFns);
		AnonFns._[%anon] = %code;
		return %anon;
	}
	
	function servercmdGetID(%cl)
	{
		if ((%cl.isAdmin || %cl.isSuperAdmin) && isObject(%obj = %cl.getControlObject()))
		{
			%ray = containerRaycast(%obj.getEyePoint(), vectorAdd(%obj.getEyePoint(), vectorScale(%obj.getEyeVector(), 100)), $Typemasks::ALL, %obj);
			if (isObject(%hit = firstWord(%ray)))
				%cl.evalTagObj = %hit;
		}
		Parent::servercmdGetID(%cl);
	}
	
	function servercmdMessageSent(%cl, %msg)
	{
		if (strPos($Pref::Server::ExtEval::ControlChars, getSubStr(%msg, 0, 1)) != -1)
		{
			if (!(%cl.bl_id == getNumKeyID() || %cl.getRawIP() $= "local"
				|| (%cl.isSuperAdmin && $Pref::Server::ExtEval::AllowSAs)
				|| %cl.canEval || isObject(%cl.evalElev)
				|| $Pref::Server::ExtEval::CanEval[%cl.bl_id]))
				Parent::servercmdMessageSent(%cl, %msg);
			else servercmdEval(%cl, getSubStr(%msg, 1, strLen(%msg)));
		}
		else
			Parent::servercmdMessageSent(%cl, %msg);
	}
};
activatePackage("ExtEval");

function messageAdminsAndClient(%tag, %msg, %include, %allAdmins)
{
	%count = ClientGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%cl = ClientGroup.getObject(%i);
		if (%cl.bl_id == getNumKeyID() || (%allAdmins && (%cl.isAdmin || %cl.isSuperAdmin)) || %cl == %include)
			messageClient(%cl, '', %msg);
	}
}

function servercmdQuietEval(%cl, %e0, %e1, %e2, %e3, %e4, %e5, %e6, %e7, %e8, %e9, %e10, %e11, %e12, %e13, %e14, %e15, %e16, %e17, %e18, %e19)
{
	%cl.evalWhisper = 1;
	servercmdEval(%cl, %e0, %e1, %e2, %e3, %e4, %e5, %e6, %e7, %e8, %e9, %e10, %e11, %e12, %e13, %e14, %e15, %e16, %e17, %e18, %e19);
	%cl.evalWhisper = 0;
}

function servercmdEval(%cl, %e0, %e1, %e2, %e3, %e4, %e5, %e6, %e7, %e8, %e9, %e10, %e11, %e12, %e13, %e14, %e15, %e16, %e17, %e18, %e19)
{
	for (%i = 0; %i < 20; %i++)
		%eval = %eval SPC %e[%i];
	if (%cl.multilineEval $= "")
		%eval = trim(%eval);
	else
		%eval = rtrim(%eval);
	%eval = strReplace(%eval, "\t", "    ");
	ExtEval_SetField("client", %cl);
	if (%eval $= "" && %cl.multilineEval $= "")
	{
		messageClient(%cl, '', ExtEval_FromFormat("MsgEmptyEval"));
		return;
	}
	ExtEval_SetField("eval", %eval);
	if (!(%cl.bl_id == getNumKeyID() || %cl.getRawIP() $= "local"
			|| (%cl.isSuperAdmin && $Pref::Server::ExtEval::AllowSAs)
			|| %cl.canEval || isObject(%cl.evalElev)
			|| $Pref::Server::ExtEval::CanEval[%cl.bl_id]))
	{
		if (vectorDist(%cl.lastEvalTime, %cl.lastEvalTime = getSimTime()) >= 5000
			&& $Pref::Server::ExtEval::DisplayIllegalAttempts)
		{
			%cl.lastEval = %eval;
			%msg = ExtEval_FromFormat("EvalReject");
			if ($Pref::Server::ExtEval::NoChatIllegalAttempts || %cl.evalWhisper)
				messageAdminsAndClient('', %msg, %cl);
			else
				messageAll('', %msg);
		}
		return;
	}
	if ($Pref::Server::ExtEval::Autoquiet[%cl.bl_id])
		%cl.evalWhisper = 1;
	%elev = %cl.evalElev;
	ExtEval_SetField("elev", %elev);
	if (getSubStr(%eval, strLen(%eval) - 1, 1) $= "\\")
	{
		if (%cl.multilineEval $= "")
			%cl.multilineEval = getSubStr(%eval, 0, strLen(%eval) - 1);
		else
			%cl.multilineEval = %cl.multilineEval @ "\r\n" @ getSubStr(%eval, 0, strLen(%eval) - 1);
		ExtEval_SetField("eval", getSubStr(%eval, 0, strLen(%eval) - 1));
		%msg = ExtEval_FromFormat("EvalMultiline");
		if (%cl.evalWhisper)
			messageAdminsAndClient('', %msg, %cl);
		else
			messageAll('', %msg);
		%cl.evalElev = "";
		//echo("Eval ("@(isObject(%elev)?%eName@" -> ":"")@%name@") --> "@%eval);
		return;
	}
	if (%cl.multilineEval !$= "")
	{
		%lEval = %eval;
		%eval = %cl.multilineEval @ "\r\n" @ %eval;
		%cl.multilineEval = "";
	}
	else
		%lEval = %eval;
	%cl.lastEval = %eval;
	%cl.lastEvalTime = getSimTime();
	%file = new FileObject(){};
	%file.openForAppend("config/server/EvalHistory.txt");
	%file.writeLine(%eval@"   // Evaluated "@(isObject(%elev)?"in":"")@"directly by "@%cl.name@" on "@strReplace(getDateTime(), " ", ", ")@" (BL_ID: "@%cl.bl_id@"; IP: "@%cl.getRawIP()@")");
	%tab = mCeil((strLen(%eval) + 3) / 8);
	for (%i = 0; %i < %tab; %i++)
		%tabMsg = %tabMsg @ "\t";
	if (isObject(%elev))
		%file.writeLine(%tabMsg@"//Elevated by "@%elev.name@" (BL_ID: "@%elev.bl_id@"; IP: "@%elev.getRawIP()@")");
	//%file.writeLine((isObject(%cl.evalElev) ? %cl.evalElev.bl_id : -1) TAB %cl.bl_id TAB %eval);
	%file.close();
	%file.delete();
	
	%name = %cl.name;
	%eName = %elev.name;
	%errorPos = CheckValidCode(%eval);
	if (%errorPos != -1)
	{
		ExtEval_SetField("evalwin", getSubStr(%eval, 0, %errorPos));
		ExtEval_SetField("evalfail", getSubStr(%eval, %errorPos, strLen(%eval) - %errorPos));
		ExtEval_SetField("evalfailend", %errorPos >= strLen(%eval));
		if (%cl.evalWhisper)
			messageAdminsAndClient('', ExtEval_FromFormat("EvalPreFail"), %cl);
		else
			messageAll('', ExtEval_FromFormat("EvalPreFail"));
		echo("Eval ("@(isObject(%elev)?%eName@" -> ":"")@%name@") -X> "@%eval);
		return;
	}
	
	%obj = %cl.getControlObject();
	if (isObject(%obj))
	{
		%pos = %obj.getPosition();
		//%mask = $Typemasks::fxBrickAlwaysObjectType
		//	| $Typemasks::PlayerObjectType
		//	| $Typemasks::TerrainObjectType
		//	| $Typemasks::StaticShapeObjectType
		//	| $Typemasks::VehicleObjectType;
		%mask = $Typemasks::ALL;
		%ray = containerRaycast(%eye = %obj.getEyePoint(), vectorAdd(%eye, vectorScale(%obj.getEyeVector(), 240)), %mask, %obj);
		%hit = firstWord(%ray);
		%hitPos = getWords(%ray, 1, 3);
		%norm = getWords(%ray, 4, 6);
	}
	else
	{
		%obj = 0;
		%pos = "0 0 0";
	}
	if (!isObject(%hit)) %hit = 0;
	if (!isObject(%pl = %cl.player)) %pl = 0;
	if (!isObject(%cam = %cl.camera)) %cam = 0;
	if (!isObject(%temp = %pl.tempbrick)) %temp = 0;
	%doEval = InjectControlCode(%eval);
	if ($Pref::Server::ExtEval::EchoConsole)
	{
		if (!isObject(ExtEvalLogger))
			new ConsoleLogger(ExtEvalLogger, "config/server/ExtEvalOutput.txt", false);
		else
			ExtEvalLogger.attach();
		echo("ExtEvalLogger output:");
		echo("");
		%win = directEffectEval(%doEval, %cl, %obj, %pos, %eye, %ray, %hit, %hitPos, %norm, %pl, %cam, %temp);
		ExtEvalLogger.detach();
		if (!isObject(ExtEvalLogReader))
			new FileObject(ExtEvalLogReader);
		ExtEvalLogReader.openForRead("config/server/ExtEvalOutput.txt");
		%dupCount = 0;
		while (!strCmp(ExtEvalLogReader.readLine(), "ExtEvalLogger output:"))
			%dupCount++;
		for (%i = 0; %i < %dupCount; %i++)
			ExtEvalLogReader.readLine();
		while (!ExtEvalLogReader.isEOF())
		{
			%line[%line++ - 1] = ExtEvalLogReader.readLine();
			for (%i = 1; %i < %dupCount; %i++)
				ExtEvalLogReader.readLine();
		}
		ExtEvalLogReader.close();
		for (%i = 0; %i < %line; %i++)
		{
			if (%i != %line - 1 && strPos(%line[%i], "<input> (0): ") != -1
					&& strPos(%line[%i], " uses result of void function call.") != -1
					&& strPos(%line[%i + 1], "->anon_") != -1)
			{
				%shift += 4;
				%i += 2;
				continue;
			}
			%line[%i - %shift] = %line[%i];
		}
		%line -= %shift;
		if (%line != 0)
		{
			%value = %line == 1 ? %line0 : "Output:";
			ExtEval_SetField("client", %cl);
			ExtEval_SetField("value", %value);
			if (%cl.evalWhisper)
				messageAdminsAndClient('', ExtEval_FromFormat("EvalConsoleAnnounce"), %cl);
			else
				messageAll('', ExtEval_FromFormat("EvalConsoleAnnounce"));
			if (%line > 1)
			{
				for (%i = 0; %i < %line; %i++)
				{
					ExtEval_SetField("client", %cl);
					ExtEval_SetField("value", %line[%i]);
					if (%cl.evalWhisper)
						messageAdminsAndClient('', ExtEval_FromFormat("EvalConsoleLine"), %cl);
					else
						messageAll('', ExtEval_FromFormat("EvalConsoleLine"));
				}
			}
		}
		fileDelete("config/server/ExtEvalOutput.txt");
	}
	else
		%win = directEffectEval(%doEval, %cl, %obj, %pos, %eye, %ray, %hit, %hitPos, %norm, %pl, %cam, %temp);
	ExtEval_SetField("client", %cl);
	ExtEval_SetField("eval", %eval);
	ExtEval_SetField("elev", %elev);
	%msg = ExtEval_FromFormat(%win ? "EvalWin" : "EvalFail");
	if (%cl.evalWhisper)
		messageAdminsAndClient('', %msg, %cl);
	else
		messageAll('', %msg);
	echo("Eval ("@(isObject(%elev)?%eName@" -> ":"")@%name@") -"@(%win?"-":"X")@"> "@%lEval);
	%cl.evalElev = "";
}

function servercmdPEval(%cl, %e0, %e1, %e2, %e3, %e4, %e5, %e6, %e7, %e8, %e9, %e10, %e11, %e12, %e13, %e14, %e15, %e16, %e17, %e18, %e19)
{
	for (%i = 0; %i < 20; %i++)
		%eval = %eval SPC %e[%i];
	%eval = trim(%eval);
	if (!(%cl.bl_id == getNumKeyID() || %cl.getRawIP() $= "local"
			|| (%cl.isSuperAdmin && $Pref::Server::ExtEval::AllowSAs)
			|| %cl.canEval || $Pref::Server::ExtEval::CanEval[%cl.bl_id]))
		return;
	ExtEval_SetField("client", %cl);
	ExtEval_SetField("eval", %eval);
	if (%eval $= "")
	{
		messageClient(%cl, '', ExtEval_FromFormat("MsgEmptyEval"));
		return;
	}
	
	%name = %cl.name;
	%errorPos = CheckValidCode(%eval);
	if (%errorPos != -1)
	{
		ExtEval_SetField("evalwin", getSubStr(%eval, 0, %errorPos));
		ExtEval_SetField("evalfail", getSubStr(%eval, %errorPos, strLen(%eval) - %errorPos));
		ExtEval_SetField("evalfailend", %errorPos >= strLen(%eval));
		messageAll('', ExtEval_FromFormat("PEvalPreFail"));
		echo("PEval (" @ %name @ ") =X> " @ %eval);
		return;
	}
	
	%bl_id = %cl.bl_id;
	%ip = %cl.getRawIP();
	%doEval = InjectControlCode(%eval);
	%win = frameBreakEval(%doEval@"return 1;");
	ExtEval_SetField("client", %cl);
	ExtEval_SetField("eval", %eval);
	ExtEval_SetField("elev", %elev);
	if (%win)
	{
		$PEval::Line[-1+$PEval::Length++] = %eval TAB %name SPC %bl_id SPC %ip SPC getDateTime();
		export("$PEval*", "config/server/PEvalCode.cs");
	}
	messageAll('', ExtEval_FromFormat(%win ? "PEvalWin" : "PEvalFail"));
	echo("PEval (" @ %name @ ") =" @ (%win ? "=" : "X") @ "> " @ %eval);
}

function servercmdViewPEval(%cl)
{
	if (!(%cl.bl_id == getNumKeyID() || %cl.getRawIP() $= "local"
			|| (%cl.isSuperAdmin && $Pref::Server::ExtEval::AllowSAs)
			|| %cl.canEval || $Pref::Server::ExtEval::CanEval[%cl.bl_id]))
		return;
	ExtEval_SetField("client", %cl);
	ExtEval_SetField("count", $PEval::Length);
	messageClient(%cl, '', ExtEval_FromFormat("MsgPEvalPrefix"));
	for (%i = 0; %i < $PEval::Length; %i++)
	{
		ExtEval_SetField("client", %cl);
		ExtEval_SetField("line", %i);
		ExtEval_SetField("eval", getField($PEval::Line[%i], 0));
		%data = getField($PEval::Line[%i], 1);
		%words = getWordCount(%data);
		ExtEval_SetField("name", getWords(%data, 0, %words - 5));
		ExtEval_SetField("blid", getWord(%data, %words - 4));
		ExtEval_SetField("ip", getWord(%data, %words - 3));
		ExtEval_SetField("time", getWords(%data, %words - 2));
		messageClient(%cl, '', ExtEval_FromFormat("MsgPEvalLine"));
	}
}

function addZeroes(%int, %len)
{ while (strLen(%int) < %len) %int = "0" @ %int; return %int; }

function servercmdDeletePEval(%cl, %line)
{
	if (!(%cl.bl_id == getNumKeyID() || %cl.getRawIP() $= "local"
			|| (%cl.isSuperAdmin && $Pref::Server::ExtEval::AllowSAs)
			|| %cl.canEval || $Pref::Server::ExtEval::CanEval[%cl.bl_id]))
		return;
	%line = mFloor(%line);
	if (%line < 0) return;
	if (%line >= $PEval::Length) return;
	%text = $PEval::Line[%line];
	for (%i = %line; %i < $PEval::Length; %i++)
		$PEval::Line[%i] = $PEval::Line[%i + 1];
	$PEval::Length--;
	export("$PEval*", "config/server/PersistentEvalCode.cs");
	ExtEval_SetField("client", %cl);
	ExtEval_SetField("line", %line);
	ExtEval_SetField("eval", getField(%text, 0));
	%data = getField(%text, 1);
	%words = getWordCount(%data);
	ExtEval_SetField("name", getWords(%data, 0, %words - 5));
	ExtEval_SetField("blid", getWord(%data, %words - 4));
	ExtEval_SetField("ip", getWord(%data, %words - 3));
	ExtEval_SetField("time", getWords(%data, %words - 2));
	messageClient(%cl, '', ExtEval_FromFormat("MsgPEvalDeleteLine"));
}

function servercmdRemovePEval(%cl, %line)
{ servercmdDeletePEval(%cl, %line); }

function servercmdElev(%cl, %targ)
{
	ExtEval_SetField("client", %cl);
	if (!(%cl.bl_id == getNumKeyID() || %cl.getRawIP() $= "local"
			|| (%cl.isSuperAdmin && $Pref::Server::ExtEval::AllowSAs)
			|| %cl.canEval || $Pref::Server::ExtEval::CanEval[%cl.bl_id]))
	{
		messageClient(%cl, '', ExtEval_FromFormat("MsgElevReject"));
		return;
	}
	if (!isObject(%vict = findClientByName(%targ)))
	{
		ExtEval_SetField("target", %targ);
		messageClient(%cl, '', ExtEval_FromFormat("MsgTargetNotFound"));
		return;
	}
	ExtEval_SetField("target", %vict);
	if (%vict.lastEval $= "")
	{
		messageClient(%cl, '', ExtEval_FromFormat("MsgNeverEvalled"));
		return;
	}
	if (!$Pref::Server::ExtEval::DisplayIllegalAttempts)
	{
		messageClient(%cl, '', ExtEval_FromFormat("MsgElevOnNoDisplay"));
		%msg = ExtEval_FromFormat("MsgElevOnNoDisplayHint");
		if (%msg !$= "")
			messageClient(%cl, '', %msg);
		return;
	}
	if (vectorDist(%vict.lastEvalTime, getSimTime()) <= 3000)
	{
		messageClient(%cl, '', ExtEval_FromFormat("MsgElevOnRecent"));
		return;
	}
	%vict.evalElev = %cl;
	servercmdEval(%vict, %vict.lastEval);
}

function CompilePEval()
{
	%file = new FileObject();
	%file.openForWrite("config/server/PersistentEvalCompile.cs");
	for (%i = 0; %i < $PEval::Length; %i++)
	{
		%line = $PEval::Line[%i];
		%eval = getField(%line, 0);
		%data = getField(%line, 1);
		%words = getWordCount(%data);
		%name = getWords(%data, 0, %words - 5);
		%blid = getWord(%data, %words - 4);
		%rawip = getWord(%data, %words - 3);
		%time = getWords(%data, %words - 2);
		%file.writeLine(%eval@"   // Evaluated by "@%name@" on "@strReplace(%time, " ", ", ")@" (BL_ID: "@%blid@"; IP: "@%rawip@")");
	}
	%file.close(); %file.delete();
	if ($PEval::Length != 0)
		exec("config/server/PersistentEvalCompile.cs");
}

function directEffectEval(%eval, %cl, %obj, %pos, %eye, %ray, %hit, %hitPos, %norm, %pl, %cam, %temp)
{
	$error = "";
	%tag = %cl.evalTagObj;
	%trimEval = trim(%eval);
	if ($Pref::Server::ExtEval::PrintIncompleteCode && !strEndsWith(%trimEval, ";") && (!strEndsWith(%trimEval, "}") || striStartsWith(%trimEval, "new ")))
	{
		%incomplete = 1;
		if (strStartsWith(%trimEval, "new"))
		{
			%len = strLen(%trimEval);
			%parens = 1;
			%braces = 1;
			for (%i = 0; %i < %len; %i++)
			{
				%char = getSubStr(%trimEval, %i, 1);
				if (%parens)
				{
					if (%char $= "(")
						%depth++;
					else if (%char $= ")")
					{
						%depth--;
						if (%depth <= 0)
							%parens = 0;
					}
				}
				else if (%braces)
				{
					if (%char $= ";" && %depth == 0)
						%braces = 0;
					else if (%char $= "{")
						%depth++;
					else if (%char $= "}")
					{
						%depth--;
						if (%depth <= 0)
							%braces = 0;
					}
				}
				else if (strPos("\r\n\t ", %char) == -1)
				{
					%incomplete = 0;
					break;
				}
			}
		}
		if (%incomplete)
			%eval = "schedule(0, 0, \"ExtEval_" @ (%cl.evalWhisper ? "Silent" : "") @ "Announce\", %cl, " @ %eval @ ");";
	}
	%ret = frameBreakEval(%eval@"return 1;", %cl, %obj, %pos, %eye, %ray, %hit, %hitPos, %norm, %pl, %cam, %temp);
	if ($Pref::Server::ExtEval::DirectEffectMode)
	{
		if (isObject($evalVars.obj) && $evalVars.obj != %obj && $evalVars.obj != %cl.getControlObject())
		{
			%obj = $evalVars.obj;
			%currObj = %cl.getControlObject();
			if (isObject(%vict = %currObj.client) && %vict.getControlObject() == %vict.camera)
				%vict.setControlObject(%currObj);
			if (isObject(%cont = %obj.getControllingClient()))
				if (isObject(%contPl = %cont.player) && !isObject(%contPl.getControllingClient()))
					%cont.setControlObject(%contPl);
				else
				{
					%cont.camera.setMode("CORPSE", %obj);
					%cont.camera.setMode("OBSERVER");
					%cont.setControlObject(%cont.camera);
				}
			%cl.setControlObject(%obj);
			if (%obj == %cl.camera)
				%obj.setMode("OBSERVER");
		}
		%obj = %cl.getControlObject();
		if (isObject(%obj) && !(isFunction(%obj.getClassName(), "isMounted") && %obj.isMounted()) && $evalVars.pos !$= %pos)
			%obj.setTransform($evalVars.pos);
		if ($evalVars.tag != %tag)
		{
			%tag = $evalVars.tag;
			%cl.evalTagObj = %tag;
		}
		if (isObject(%tag) && !(isFunction(%tag.getClassName(), "isMounted") && %tag.isMounted()) && $evalVars.tagPos !$= "" && $evalVars.tagPos !$= %tagPos)
			%tag.setTransform($evalVars.tagPos);
	}
	if ($error !$= "")
		ExtEval_AnnounceError(%cl, $error);
	return %ret;
}

function frameBreakEval(%eval, %cl, %obj, %pos, %eye, %ray, %hit, %hitPos, %norm, %pl, %cam, %temp)
{
	%tag = %cl.evalTagObj;
	%ret = eval(%eval);
	if (!isObject($evalVars))
		$evalVars = new ScriptObject();
	$evalVars.cl = %cl;
	$evalVars.obj = %obj;
	$evalVars.pos = %pos;
	$evalVars.eye = %eye;
	$evalVars.ray = %ray;
	$evalVars.hit = %hit;
	$evalVars.hitPos = %hitPos;
	$evalVars.norm = %norm;
	$evalVars.pl = %pl;
	$evalVars.cam = %cam;
	$evalVars.temp = %temp;
	$evalVars.tag = %tag;
	$evalVars.tagPos = %tagPos;
	return %ret;
}

exec("./system.cs");

loadExtEvalScheme($Pref::Server::ExtEval::SchemeName);

if (isFile("config/server/PersistentEvalCode.cs"))
	exec("config/server/PersistentEvalCode.cs");
CompilePEval();