// Container search shortcuts
function containerBoxSearch(%pos, %box, %mask, %callback)
{
	initContainerBoxSearch(%pos, %box, %mask);
	for (%obj = containerSearchNext(); isObject(%obj); %obj = containerSearchNext())
		call(%callback, %obj);
	return "";
}

function containerRadiusSearch(%pos, %radius, %mask, %callback)
{
	initContainerRadiusSearch(%pos, %radius, %mask);
	for (%obj = containerSearchNext(); isObject(%obj); %obj = containerSearchNext())
		call(%callback, %obj);
	return "";
}

function inBox(%pos, %box, %mask, %callback)
{
	return containerBoxSearch(%pos, %box, %mask, %callback);
}

function inRadius(%pos, %radius, %mask, %callback)
{
	return containerRadiusSearch(%pos, %radius, %mask, %callback);
}

// Common client and player shortcuts
function fcbn(%name)
{
	return findClientByName(%name);
}

function fpbn(%name)
{
	for (%i = ClientGroup.getCount() - 1; %i >= 0; %i--)
	{
		%cl = ClientGroup.getObject(%i);
		if (striPos(%cl.name, %name) == -1 || !isObject(%pl = %cl.player))
			continue;
		return %pl;
	}
	return -1;
}

function GameConnection::getAdmin(%cl)
{
	return %cl.isSuperAdmin ? 2 : !!%cl.isAdmin;
}

function GameConnection::setAdmin(%cl, %level)
{
	%cl.isAdmin = %level >= 1;
	%cl.isSuperAdmin = %level >= 2;
	commandToClient(%cl, 'setAdminLevel', mClamp(%level, 0, 2));
	%cl.sendPlayerListUpdate();
}

// Typemask shortcuts
$Mask::All = $Typemasks::All;
$Mask::Camera = $Typemasks::CameraObjectType;
$Mask::Corpse = $Typemasks::CorpseObjectType;
$Mask::DamagableItem = $Typemasks::DamagableItemObjectType;
$Mask::Debris = $Typemasks::DebrisObjectType;
$Mask::Environment = $Typemasks::EnvironmentObjectType;
$Mask::Explosion = $Typemasks::ExplosionObjectType;
$Mask::FxBrickAlways = $Typemasks::FxBrickAlwaysObjectType;
$Mask::FxBrick = $Typemasks::FxBrickObjectType;
$Mask::GameBase = $Typemasks::GameBaseObjectType;
$Mask::Item = $Typemasks::ItemObjectType;
$Mask::Marker = $Typemasks::MarkerObjectType;
$Mask::PhysicalZone = $Typemasks::PhysicalZoneObjectType;
$Mask::Player = $Typemasks::PlayerObjectType;
$Mask::Projectile = $Typemasks::ProjectileObjectType;
$Mask::ShapeBase = $Typemasks::ShapeBaseObjectType;
$Mask::Static = $Typemasks::StaticObjectType;
$Mask::StaticRendered = $Typemasks::StaticRenderedObjectType;
$Mask::StaticShape = $Typemasks::StaticShapeObjectType;
$Mask::StaticTS = $Typemasks::StaticTSObjectType;
$Mask::Terrain = $Typemasks::TerrainObjectType;
$Mask::Trigger = $Typemasks::TriggerObjectType;
$Mask::VehicleBlocker = $Typemasks::VehicleBlockerObjectType;
$Mask::Vehicle = $Typemasks::VehicleObjectType;
$Mask::Water = $Typemasks::WaterObjectType;
