// load dependencies
exec("./indexers.cs");
exec("./iterators.cs");
exec("./schemes.cs");
exec("./shortcuts.cs");
exec("./X11 colors.cs");

function InjectControlCode(%code)
{
	%code = InjectLambdaNames(trim(%code));
	%len = strLen(%code);
	%brackDepth = 0;
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%code, %i, 1);
		if (%commented)
		{
			if (%char $= "\r" || %char $= "\n")
			{ %commented = 0; %comment = 0; }
			continue;
		}
		if (%code_string)
		{
			if (%char $= "\\" && !%escaped) %escaped = 1;
			else if (%char $= "\"" && !%escaped) %code_string = 0;
			else %escaped = 0;
		}
		else if (%char $= "\"")
		{
			%escaped = 0;
			%code_string = 1;
		}
		if (!%code_string && %char $= "/")
		{
			%comment++;
			%char = "";
			if (%comment >= 2)
			{
				%commented = 1;
				continue;
			}
		}
		else %comment = 0;
		if (%injectCode && %char $= "{")
		{
			if (%injectArgs >= 1)
			{
				%argList = "";
				for (%j = 0; %j < %injectArgs; %j++)
					%argList = trim(%argList) SPC %injectArg[%j];
				%argList = " " @ %argList @ " ";
				
				// keywords
				%doObj = striPos(%argList, " obj ") == -1;
				%doPos = striPos(%argList, " pos ") == -1;
				%doRay = striPos(%argList, " ray ") == -1;
				%doEye = striPos(%argList, " eye ") == -1;
				%doHit = striPos(%argList, " hit ") == -1;
				%doHitPos = striPos(%argList, " hitpos ") == -1;
				%doNorm = striPos(%argList, " norm ") == -1;
				%doPl = striPos(%argList, " pl ") == -1;
				%doCam = striPos(%argList, " cam ") == -1;
				%doTemp = striPos(%argList, " temp ") == -1;
				%doRaycast = %doRay && %doEye && (%doHit || %doHitPos || %doNorm);
				%doObjSubs = %doObj && (%doPos || %doRaycast || %doEye);
				
				// build the injection
				if (%doObj)
				{
					%inject = "%obj=%"@%injectArg0@".getControlObject();";
					if (%doObjSubs)
					{
						%inject = %inject @ "if (isObject(%obj)){";
						if (%doPos) %inject = %inject @ "%pos=%obj.getPosition();";
						if (%doEye) %inject = %inject @ "%eye=%obj.getEyePoint();";
						if (%doRaycast)
						{
							%inject = %inject @ "%ray=containerRaycast(%eye,vectorAdd(%eye,vectorScale(%obj.getEyeVector(),240)),$Typemasks::ALL,%obj);";
							if (%doHit) %inject = %inject @ "%hit=firstWord(%ray);";
							if (%doHitPos) %inject = %inject @ "%hitPos=getWords(%ray,1,3);";
							if (%doNorm) %inject = %inject @ "%norm=getWords(%ray,4,6);";
							if (%doHit) %inject = %inject @ "if (!isObject(%hit))%hit=0;";
						}
						%inject = %inject @ "}else%obj=0;";
					}
					if (%doPl) %inject = %inject @ "if (!isObject(%pl=%"@%injectArg0@".player))%pl=0;";
					if (%doCam) %inject = %inject @ "if (!isObject(%cam=%"@%injectArg0@".camera))%cam=0;";
					if (%doPl && %doTemp) %inject = %inject @ "if (!isObject(%temp=%pl.tempbrick))%temp=0;";
				}
				%code = getSubStr(%code, 0, %i + 1) @ %inject @ getSubStr(%code, %i + 1, strLen(%code) - (%i + 1));
			}
			%injectCode = 0;
		}
		if (%char $= "{")
			%brackDepth++;
		else if (%char $= "}")
		{
			%brackDepth--;
			if (%brackDepth == 0)
			{
				%fnName = "";
				if (%hoistOverrideFn)
				{
					%hoistOverrideFn = 0;
					%overrideHoist = getSubStr(%code, %overridePos, %i - %overridePos + 1);
					%code = getSubStr(%code, 0, %overridePos) @ getSubStr(%code, %i + 1, %len - (%i + 1));
					%overrideCode = %overrideCode @ "function" @ getSubStr(%overrideHoist, 8, strLen(%overrideHoist) - 8);
					%i = %overridePos - 1;
					%len = strLen(%code);
				}
			}
		}
		if (%char $= ")" && %handleForeach)
		{
			%handleForeach = 0;
			%foreachCode = getSubStr(%code, %foreachPos, %i - %foreachPos + 1);
			%parenPos = strPos(%foreachCode, "(");
			if (%parenPos != -1 && %foreachInPos != -1 && %parenPos < %foreachInPos)
			{
				%foreachInPos -= %foreachPos;
				%iteratorVar = trim(getSubStr(%foreachCode, %parenPos + 1, %foreachInPos - (%parenPos + 1)));
				%iteratorName = "%__fe" @ getSubStr(%iteratorVar, 1, strLen(%iteratorVar) - 1);
				%iterableExpr = trim(getSubStr(%foreachCode, %foreachInPos + 2, strLen(%foreachCode) - (%foreachInPos + 3)));
				%forCode = "for((%__feI" @ %foreachID @ "=0)^(%__feL" @ %foreachID
					@ "=getValueLength(%__feG" @ %foreachID @ "))^(%__feG" @ %foreachID @ "="
					@ %iterableExpr @ ");(%__feI" @ %foreachID @ "<%__feL" @ %foreachID @ ")&&(("
					@ %iteratorVar @ "=getIndexer(%__feG" @ %foreachID @ ",%__feI" @ %foreachID
					@ "))||1);%__feI" @ %foreachID @ "++)";
				%code = getSubStr(%code, 0, %foreachPos) @ %forCode @ getSubStr(%code, %i + 1, %len - (%i + 1));
				%delta = strLen(%forCode) - strLen(%foreachCode);
				%len = strLen(%code);
				%i += %delta;
				%foreachID++;
			}
		}
		if (!%code_string)
		{
			%keepMem = "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" @ (%code_memory $= "" ? "" : "0123456789:");
			if (striPos(%keepMem, %char) != -1)
				%code_memory = %code_memory @ %char;
			else
			{
				if (%code_memory !$= "" && strPos("$%", %prevChar) == -1)
				{
					%pos = %i;
					if (%injectCode)
						%injectArg[%injectArgs++ - 1] = %code_memory;
					else if (%code_lastMem $= "function" || %code_lastMem $= "override")
					{
						%fnName = %code_memory;
						if (getSubStr(%code_memory, 0, 9) $= "servercmd")
						{
							%injectCode = 1;
							%injectArgs = 0;
						}
					}
					if (%code_memory $= "override" && !%brackDepth
						&& $Pref::Server::ExtEval::SyntaxExtensions)
					{
						%hoistOverrideFn = 1;
						%overridePos = %i - 8;
					}
					if (%code_memory $= "base")   // && %hoistOverrideFn)
					{
						%pos = 0;
						while ((%npos = strPos(%fnName, "::", %pos)) != -1)
							%pos = %npos + 2;
						%callBase = "Parent::" @ getSubStr(%fnName, %pos, strLen(%fnName) - %pos);
						%delta = strLen(%callBase) - 4;
						%code = getSubStr(%code, 0, %i - 4) @ %callBase @ getSubStr(%code, %i, %len - %i);
						%len = strLen(%code);
						%i += %delta;
					}
					if (%code_memory $= "foreach" && $Pref::Server::ExtEval::SyntaxExtensions)
					{
						%handleForeach = 1;
						%foreachPos = %i - 7;
						%foreachInPos = -1;
					}
					if (%code_memory $= "in" && %handleForeach)
						%foreachInPos = %i - 2;
					if (strPos(" \r\n\t\xFF", %char) != -1)
						%code_lastMem = %code_memory;
					else
						%code_lastMem = "";
				}
				%code_memory = "";
				%prevChar = %char;
			}
		}
	}
	if (%overrideCode !$= "")
		%code = %code @ "package extEvalOverride{" @ %overrideCode @ "};";
	return %code;
}

function InjectLambdaNames(%code)
{
	%percentPos = -2;
	%dollarPos = -2;
	%len = strLen(%code);
	%stdAlpha = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_";
	%stdAlphanum = %stdAlpha @ "0123456789";
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%code, %i, 1);
		if (%commented)
		{
			if (%char $= "\r" || %char $= "\n")
			{ %commented = 0; %comment = 0; }
			continue;
		}
		if (%code_string)
		{
			if (%char $= "\\" && !%escaped) %escaped = 1;
			else if (%char $= "\"" && !%escaped) %code_string = 0;
			else %escaped = 0;
		}
		else if (%char $= "\"")
		{
			%escaped = 0;
			%code_string = 1;
			%lenStart = 0;
		}
		if (!%code_string && %char $= "/")
		{
			%comment++;
			%char = "";
			if (%comment >= 2)
			{
				%commented = 1;
				continue;
			}
		}
		else %comment = 0;
		if (%commented || %code_string)
			continue;
		
		// string interpolation
		if (%char $= "$" && getSubStr(%code, %i + 1, 1) $= "\""
			&& $Pref::Server::ExtEval::SyntaxExtensions)
		{
			%istrStart = %i;
			%escaped = 0;
			%istr = "(";
			%imode = 0;
			for (%i += 2; %i < %len; %i++)
			{
				%char = getSubStr(%code, %i, 1);
				if (%interpolate)
				{
					if (%char $= "{")
						%istrDepth++;
					else if (%char $= "}")
					{
						%istrDepth--;
						if (%istrDepth == 0)
						{
							%interpolate = 0;
							%istr = %istr @ ")";
							continue;
						}
					}
					%istr = %istr @ %char;
				}
				else if (%escaped)
				{
					%istr = %istr @ "\\" @ %char;
					%escaped = 0;
				}
				else if (%char $= "\\")
					%escaped = 1;
				else if (%char $= "\"")
					break;
				else if (%char $= "{" && getSubStr(%code, %i + 1, 1) !$= "{")
				{
					%interpolate = 1;
					%istrDepth = 1;
					if (%imode == 1)
						%istr = %istr @ "\"@";
					else if (%imode == 2)
						%istr = %istr @ "@";
					%istr = %istr @ "(";
					%imode = 2;
				}
				else if (%char $= "}" && getSubStr(%code, %i + 1, 1) !$= "}")
					%istr = %istr @ "\"";   // generate special error case
				else
				{
					if (%imode != 1)
						%istr = %istr @ (%imode == 2 ? "@\"" : "\"");
					%istr = %istr @ %char;
					if (strPos("{}", %char) != -1)
						%i++;
					%imode = 1;
				}
			}
			%istrEnd = %i++;
			if (%imode == 0)
				%istr = %istr @ "\"\"";
			else if (%imode == 1)
				%istr = %istr @ "\"";
			%istr = InjectLambdaNames(%istr @ ")");
			%code = getSubStr(%code, 0, %istrStart) @ %istr @ getSubStr(%code, %istrEnd, %len - %istrEnd);
			%origLen = %len;
			%len = strLen(%code);
			%delta = %len - %origLen;
			%i += %delta - 1;
			continue;
		}
		if (%lenMode)
		{
			// we don't care about order - if the order is wrong it'll be syntactically invalid code anyway
			if (%char $= "(" || %char $= "[" || %char $= "{")
				%lenDepth++;
			else if (%lenDepth > 0 && (%char $= ")" || %char $= "]" || %char $= "}"))
				%lenDepth--;
			else
				%lenBreak = %lenDepth == 0 && strPos("@^&*-+|?:)]};=<>/" @ (%lenStart ? "" : "%"), %char) != -1;
			if (%lenBreak || %i == %len - 1)
			{
				if (!%lenBreak)
					%i++;
				%lenCode = getSubStr(%code, %lenPos + 1, %i - (%lenPos + 1));
				%lenCode = InjectLambdaNames(%lenCode);
				%code = getSubStr(%code, 0, %lenPos) @ "getValueLength(" @ %lenCode @ ")" @ getSubStr(%code, %i, %len - %i);
				%origLen = %len;
				%len = strLen(%code);
				%delta = %len - %origLen;
				%i += %delta;
				%lenMode = 0;
			}
			if (%lenStart)
			{
				%lenStart = 0;
				if (striPos(%stdAlpha @ "%$(", %char) == -1)
					%lenMode = 0;
				else
					continue;
			}
			else
				continue;
		}
		
		if (%char $= "%")
			%percentPos = %i;
		if (%char $= "$")
			%dollarPos = %i;
		if (%arrowStart != 2 && %char $= "#" && $Pref::Server::ExtEval::SyntaxExtensions)
		{
			%lenPos = %i;
			%lenMode = 1;
			%lenStart = 1;
			%lenDepth = 0;
			continue;
		}
		if (%char $= "(" && %gotVarName)
		{
			if (%percentPos >= 0)
				%varStart = %percentPos;
			else if (%dollarPos >= 0)
				%varStart = %dollarPos;
			else
				continue;
			%varName = getSubStr(%code, %varStart, %i - %varStart);
			%inject = "call(" @ %varName;
			%injectEnd = %i + 1;
			%injectClose = 0;
			for (%j = %i + 1; %j < %len; %j++)
			{
				%bChar = getSubStr(%code, %j, 1);
				if (strPos(" \r\n\t", %bChar) != -1)
				{
					%injectEnd = %j + 1;
					continue;
				}
				else if (%bChar $= ")")
				{
					%injectClose = 1;
					%injectEnd = %j + 1;
					break;
				}
				break;
			}
			%inject = %inject @ (%injectClose ? ")" : ", ");
			%code = getSubStr(%code, 0, %varStart) @ %inject @ getSubStr(%code, %injectEnd, %len - %injectEnd);
			%origLen = %len;
			%len = strLen(%code);
			%delta = %len - %origLen;
			%i += %delta;
		}
		if (striPos(%stdAlpha, %char) != -1 && (%percentPos == %i - 1 || %dollarPos == %i - 1))
			%gotVarName = 1;
		else if (striPos(%stdAlphanum, %char) == -1 || (%i == %len - 1 && %keyword !$= ""))
		{
			%gotVarName = 0;
			if (striPos(%stdAlphanum, %char) != -1)
			{
				%keyword = %keyword @ %char;
				%i++;
			}
			if ($Pref::Server::ExtEval::SyntaxExtensions)
			{
				%wordLen = strLen(%keyword);
				if (%keyword $= "CG" && %char !$= "(")
				{
					%code = getSubStr(%code, 0, %i - %wordLen) @ "ClientGroup" @ getSubStr(%code, %i, strLen(%code) - %i);
					%len += 11 - %wordLen;
					%i += 11 - %wordLen;
				}
				if (%keyword $= "PG" && %char !$= "(")
				{
					%code = getSubStr(%code, 0, %i - %wordLen) @ "PlayerGroup" @ getSubStr(%code, %i, strLen(%code) - %i);
					%len += 11 - %wordLen;
					%i += 11 - %wordLen;
				}
				if ((%keyword $= "DM" || %keyword $= "DMG") && %char !$= "(")
				{
					%code = getSubStr(%code, 0, %i - %wordLen) @ "$DefaultMinigame" @ getSubStr(%code, %i, strLen(%code) - %i);
					%len += 16 - %wordLen;
					%i += 16 - %wordLen;
				}
				if ((%keyword $= "MB" || %keyword $= "MBG") && %char !$= "(")
				{
					%code = getSubStr(%code, 0, %i - %wordLen) @ "MainBrickgroup" @ getSubStr(%code, %i, strLen(%code) - %i);
					%len += 14 - %wordLen;
					%i += 14 - %wordLen;
				}
			}
			if (striPos(%stdAlphanum, %char) != -1)
				%i--;
			%keyword = "";
		}
		else if (!%gotVarName)
			%keyword = %keyword @ %char;
		
		if (%arrowStart == 2)
		{
			if (%char $= "(")
				%parenDepth++;
			else if (%char $= ")")
			{
				if (%parenDepth == 0)
					%terminate = 1;
				%parenDepth--;
			}
			if (%char $= "{")
				%braceDepth++;
			else if (%char $= "}")
			{
				if (%braceDepth == 0)
					%terminate = 1;
				%braceDepth--;
			}
			if (%char $= "[")
				%arrayDepth++;
			else if (%char $= "]")
			{
				if (%arrayDepth == 0)
					%terminate = 1;
				%arrayDepth--;
			}
			if (%braceDepth == 0 && %char $= ";")
				%terminate = 1;
			if ((%arrayDepth == 0 && %braceDepth == 0 && %parenDepth == 0) && %char $= ",")
				%terminate = 1;
			
			if (!%terminate && %i == (%len - 1))
			{
				%terminate = 1;
				%i = %len;
			}
			if (%terminate)
			{
				%terminate = 0;
				%arrowStart = 0;
				%oParenPos = -1;
				%cParenPos = -1;
				%cParenNum = 0;
				%percentPos = -1;
				
				if (%spaceStart $= "")
					%spaceStart = %arrowPos - 2;
				%subcode = getSubStr(%code, %arrowPos, %i - %arrowPos);
				%anon = %args @ getSubStr(%code, %spaceStart, %arrowPos - (%spaceStart + 2)) @ "=>" @ InjectLambdaNames(%subcode);
				%anon = createAnonFunction(%anon);
				if (%anon $= "")
					continue;
				%delta = strLen(%anon) - %anonLen;
				%code = getSubStr(%code, 0, %anonStart) @ "\"" @ %anon @ "\"" @ getSubStr(%code, %i, %len - %i);
				%i = vectorLen(%anon) + %anonStart - 1;
				%len = strLen(%code);
				continue;
			}
		}
		else if (%char $= "(")
		{
			%cParenNum = 0;
			%oParenPos = %i;
			if (%arrowStart != 2)
				%arrowStart = 0;
		}
		else if (%char $= ")")
		{
			%cParenNum++;
			%cParenPos = %i;
			if (%arrowStart != 2)
				%arrowStart = 0;
		}
		else if (%char $= "[")
		{
			if (%bracketDepth == 0)
				%bracketStart = %i;
			%bracketDepth++;
		}
		else if (%char $= "]")
		{
			%bracketDepth--;
			if (%bracketDepth == 0 && $Pref::Server::ExtEval::SyntaxExtensions)
			{
				%bIgnore = 0;
				%injectWrap = 0;
				%intracode = getSubStr(%code, %bracketStart + 1, %i - (%bracketStart + 1));
				if (strPos(%intracode, "[") != -1)
					%intracode = InjectLambdaNames(%intracode);
				
				for (%j = %bracketStart - 1; %j >= 0; %j--)
				{
					%bChar = getSubStr(%code, %j, 1);
					if (%bString)
					{
						if (%bChar $= "\"")
							%bEscape = 1;
						else
						{
							if (%bEscape && %bChar !$= "\\")
								%bString = 0;
							%bEscape = 0;
						}
					}
					else if (%bGotString)
						break;
					else if (%bIgnore > 0 || (%bChar $= "\"" && %j == %bracketStart - 1))
					{
						if (%bChar $= "\"")
							%bGotString = %bString = 1;
						continue;
					}
					else if (%bChar $= "(" && %bIgnore > 0)
						%bIgnore--;
					else if (striPos(%stdAlphanum @ ".:)", %bChar) == -1)
					{
						%brackVarStart = %j + (%bChar $= "%" || %bChar $= "$" ? 0 : 1);
						if (%bChar $= "%" || %bChar $= "$")
							%injectWrap = 1;
						break;
					}
					else if (%bChar $= ")")
						%bIgnore++;
				}
				if (%brackVarStart $= "")
					%brackVarStart = 0;
				%varName = getSubStr(%code, %brackVarStart, %bracketStart - %brackVarStart);
				
				%dotPos = strPos(%intracode, "..");
				if (%dotPos != -1)
				{
					%bEscape = 0;
					%bLen = strLen(%intracode);
					%bString = 0;
					for (%j = 0; %j < %bLen; %j++)
					{
						%bChar = getSubStr(%intracode, %j, 1);
						if (%bString)
						{
							if (%bEscape)
							{
								%bEscape = 0;
								continue;
							}
							if (%bChar $= "\\")
								%bEscape = 1;
							else if (%bChar $= "\"")
								%bString = 0;
						}
						else if (%bChar $= "\"")
							%bString = 1;
						else if (%bChar $= ".")
						{
							%bDotNum++;
							if (%bDotNum >= 2)
							{
								%dotPos = %j - 1;
								%raw = 1;
								break;
							}
						}
						else
							%bDotNum = 0;
					}
					%start = getSubStr(%intracode, 0, %dotPos);
					%end = getSubStr(%intracode, %dotPos + 2, strLen(%intracode) - (%dotPos + 2));
					%intracode = "(" @ %start @ ") @ \"..\" @ (" @ %end @ ")";
				}
				if (strStartsWith(trim(%intracode), "="))
				{
					%intracode = "\"" @ expandEscape(%intracode) @ "\"";
					%raw = 1;
				}
				
				for (%j = %i + 1; %j < %len; %j++)
				{
					%bChar = getSubStr(%code, %j, 1);
					if (strPos("\r\n\t ", %bChar) != -1)
						continue;
					if (%bChar $= "=" && getSubStr(%code, %j + 1, 1) !$= "=")
						%set = 1;
					break;
				}
				
				if (%set)
					continue;
				
				if (!%raw)
				{
					if (strPos(%intracode, "[") != -1)
						%intracode = InjectLambdaNames(%intracode);
					if ((%dotPos = strPos(%varName, ".")) != -1)
					{
						while ((%nextDot = strPos(%varName, ".", %dotPos + 1)) != -1)
							%dotPos = %nextDot;
						%lastField = getSubStr(%varName, %dotPos + 1, strLen(%varName) - (%dotPos + 1));
						%valid = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
						%lfieldLen = strLen(%lastField);
						%isValidField = 1;
						for (%j = 0; %j < %lfieldLen; %j++)
						{
							%bChar = getSubStr(%lastField, %j, 1);
							%validColon = %j != 0 && %j != %lfieldLen - 1 ? ":" : "";
							if (striPos(%valid @ %validColon, %bChar) == -1)
							{
								%isValidField = 0;
								break;
							}
							if (%j == 0)
								%valid = %valid @ "0123456789";
						}
						if (%isValidField)
							%injectWrap = 1;
					}
					if (!%injectWrap)
						%brackInject = "getIndexer(" @ %varName @ ", " @ %intracode @ ")";
					else
						%brackInject = "(" @ %varName @ "[" @ %intracode @ "] !$= \"\" ? " @ %varName @ "[" @ %intracode @ "] : getIndexer(" @ %varName @ ", " @ %intracode @ "))";
				}
				else
					%brackInject = "getIndexer(" @ %varName @ ", " @ %intracode @ ", 1)";
				
				// *extra*-hacky workaround to handle sequential indexers, i.e. %var[0][0]
				%seq = 1;
				while (%seq)
				{
					%raw = 0;
					%seq = 0;
					for (%j = %i + 1; %j < %len; %j++)
					{
						%bChar = getSubStr(%code, %j, 1);
						if (strPos("\r\n\t ", %bChar) != -1)
							continue;
						if (%bChar $= "[")
							%seq = 1;
						break;
					}
					if (!%seq)
						break;
					%bracketDepth = 1;
					%bStart = %i + 2;
					for (%i += 2; %i < %len && %bracketDepth; %i++)
					{
						%bChar = getSubStr(%code, %i, 1);
						if (%bChar $= "[")
							%bracketDepth++;
						else if (%bChar $= "]")
							%bracketDepth--;
					}
					if (%bracketDepth)
						break;
					
					%bDotNum = 0;
					%bEscape = 0;
					%bIgnore = 0;
					%bString = 0;
					%injectWrap = 0;
					%intracode = getSubStr(%code, %bStart, %i-- - %bStart);
					if (strPos(%intracode, "[") != -1)
						%intracode = InjectLambdaNames(%intracode);
					%dotPos = strPos(%intracode, "..");
					if (%dotPos != -1)
					{
						%bLen = strLen(%intracode);
						for (%j = 0; %j < %bLen; %j++)
						{
							%bChar = getSubStr(%intracode, %j, 1);
							if (%bString)
							{
								if (%bEscape)
								{
									%bEscape = 0;
									continue;
								}
								if (%bChar $= "\\")
									%bEscape = 1;
								else if (%bChar $= "\"")
									%bString = 0;
							}
							else if (%bChar $= "\"")
								%bString = 1;
							else if (%bChar $= ".")
							{
								%bDotNum++;
								if (%bDotNum >= 2)
								{
									%dotPos = %j - 1;
									%raw = 1;
									break;
								}
							}
							else
								%bDotNum = 0;
						}
						%start = getSubStr(%intracode, 0, %dotPos);
						%end = getSubStr(%intracode, %dotPos + 2, strLen(%intracode) - (%dotPos + 2));
						%intracode = "(" @ %start @ ") @ \"..\" @ (" @ %end @ ")";
					}
					if (strStartsWith(trim(%intracode), "="))
					{
						%intracode = "\"" @ expandEscape(%intracode) @ "\"";
						%raw = 1;
					}
					%brackInject = "getIndexer(" @ %brackInject @ ", " @ %intracode @ (%raw ? ", 1)" : ")");
				}
				
				for (%j = %i + 1; %j < %len; %j++)
				{
					%bChar = getSubStr(%code, %j, 1);
					if (strPos("\r\n\t ", %bChar) != -1)
						continue;
					if (%bChar $= "=" && getSubStr(%code, %j + 1, 1) !$= "=")
						%set = 1;
					break;
				}
				if (%set)
					continue;
				
				%code = getSubStr(%code, 0, %brackVarStart) @ %brackInject @ getSubStr(%code, %i + 1, strLen(%code) - (%i + 1));
				%i = %brackVarStart + strLen(%brackInject);
				%len = strLen(%code);
			}
		}
		else if (strPos("\r\n\t ", %char) != -1)
			continue;
		else if (%arrowStart == 0 && %char $= "=")
			%arrowStart = 1;
		else if (%arrowStart == 1 && %char $= ">")
		{
			if (%cParenNum == 1)
			{
				%args = getSubStr(%code, %oParenPos, %cParenPos - %oParenPos + 1);
				%anonStart = %oParenPos;
				%spaceStart = %cParenPos + 1;
			}
			else if (%cParenNum == 0 && %percentPos >= 0)
			{
				%spaceStart = "";
				%anonStart = %percentPos;
				%args = getSubStr(%code, %anonStart, (%i - 1) - %anonStart);
				%aLen = strLen(trim(%args));
				if (!strStartsWith(%args, "%"))
					%cancel = 1;
				%valid = %stdAlpha;
				for (%j = 1; %j < %aLen; %j++)
				{
					%aChar = getSubStr(%args, %j, 1);
					if (striPos(%valid, %aChar) == -1)
					{
						%cancel = 1;
						break;
					}
					if (%j == 1)
						%valid = %stdAlphanum;
				}
				if (%cancel)
				{
					%cancel = 0;
					%arrowStart = 0;
					%oParenPos = -1;
					%cParenPos = -1;
					%cParenNum = 0;
					continue;
				}
			}
			else
				continue;
			%arrayDepth = 0;
			%braceDepth = 0;
			%parenDepth = 0;
			if ($Pref::Server::ExtEval::SyntaxExtensions)
				%arrowStart = 2;
			%arrowPos = %i + 1;
		}
		else if (%arrowStart != 2)
		{
			%arrowStart = 0;
			if (%cParenNum != 0)
			{
				%oParenPos = -1;
				%cParenPos = -1;
				%cParenNum = 0;
			}
		}
	}
	return %code;
}

function CheckValidCode(%code)
{
	%len = strLen(%code);
	for (%i = 0; %i < %len; %i++)
	{
		%char = getSubStr(%code, %i, 1);
		if (%commented)
		{
			if (%char $= "\r" || %char $= "\n")
			{ %commented = 0; %comment = 0; }
			continue;
		}
		if (%code_string)
		{
			if (%char $= "\\" && !%escaped) %escaped = 1;
			else if (%char $= "\"" && !%escaped) %code_string = 0;
			else %escaped = 0;
		}
		else if (%char $= "\"")
		{
			%escaped = 0;
			%code_string = 1;
		}
		if (!%code_string && %char $= "/")
		{
			%comment++;
			%char = "";
			if (%comment >= 2)
			{
				%commented = 1;
				continue;
			}
		}
		else %comment = 0;
		if (!%code_string)
		{
			%keepMem = "_ABCDEFGHIJKLMNOPQRSTUVWXYZ" @ (%code_memory $= "" ? "" : "0123456789:");
			if (striPos(%keepMem, %char) != -1)
				%code_memory = %code_memory @ %char;
			else if (%code_memory !$= "")
			{
				%pos = %i;
				%validCodeIdentifiers = " new datablock package function if else while switch ";
				if (striPos(%validCodeIdentifiers, " "@%code_memory@" ") != -1)
				{ %canIncBlock = 1; %incMode = %code_memory $= "new"; }
				else if (%code_memory $= "for") %canIncBlock = 3;
				%code_lastMem = %code_memory;
				%code_memory = "";
			}
			if (%char $= ";")
			{
				if (%canIncBlock > 0)
					%canIncBlock--;
				%pos = %i + 1;
				%nextChar = getSubStr(%code, %pos, 1);
				while (striPos(" \t\r\n\xFF", %nextChar) != -1)
					%nextChar = getSubStr(%code, %pos++, 1);
				if (%nextChar $= ";") return %i + 1;
			}
			if (striPos("([{", %char) != -1)
			{
				%pairStack = %pairStack @ %char;
				if (%char $= "{" && !$Pref::Server::ExtEval::SyntaxExtensions)
				{
					if (%canIncBlock != 1) return %i; %canIncBlock = 0;
					if (!%incMode && strReplace(%pairStack, "{", "") !$= "") return %i;
				}
			}
			else if ((%pos = striPos(")]}", %char)) != -1)
			{
				%stackLen = strLen(%pairStack);
				if (%stackLen == 0) return %i;
				%pair = getSubStr(%pairStack, %stackLen - 1, 1);
				if (striPos("([{", %pair) != %pos) return %i;
				%pairStack = getSubStr(%pairStack, 0, %stackLen - 1);
			}
		}
	}
	if (%pairStack !$= "") return %i;
	return -1;
}

if (!isPackage("extEvalOverride"))
{
	// NOTE: packages are not syntactically valid unless they contain at least one function.
	// Hopefully nobody depends on a function called _
	eval("package extEvalOverride{function _(){}};");
	activatePackage("extEvalOverride");
}